import{S as ot,i as rt,s as st,e as s,k as d,w as Xe,t as o,M as ct,c,d as a,m,a as n,x as Ye,h as r,b as _,G as t,g as l,y as Ze,L as nt,q as et,o as tt,B as at,v as it}from"../../chunks/vendor-hf-doc-builder.js";import{I as lt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ht}from"../../chunks/CodeBlock-hf-doc-builder.js";function pt(Le){let g,M,v,y,q,b,te,I,ae,F,A,oe,W,k,E,re,z,se,ce,ne,w,ie,$,le,he,T,pe,H,h,de,C,me,_e,P,ue,fe,D,ge,ve,O,ye,ke,J,x,we,K,S,p,be,L,Ee,je,U,Ae,ze,B,$e,Ce,G,Pe,xe,Q,R,Se,V,j,X;return b=new lt({}),j=new ht({props:{code:`from accelerate import Accelerator
import torch

accelerator = Accelerator(project_dir="my/save/path")

my_scheduler = torch.optim.lr_scheduler.StepLR(my_optimizer, step_size=1, gamma=0.99)
my_model, my_optimizer, my_training_dataloader = accelerator.prepare(my_model, my_optimizer, my_training_dataloader)

# Register the LR scheduler
accelerator.register_for_checkpointing(my_scheduler)

# Save the starting state
accelerator.save_state()

device = accelerator.device
my_model.to(device)

# Perform training
for epoch in range(num_epochs):
    for batch in my_training_dataloader:
        my_optimizer.zero_grad()
        inputs, targets = batch
        inputs = inputs.to(device)
        targets = targets.to(device)
        outputs = my_model(inputs)
        loss = my_loss_function(outputs, targets)
        accelerator.backward(loss)
        my_optimizer.step()
    my_scheduler.step()

# Restore previous state
accelerator.load_state("my/save/path/checkpointing/checkpoint_0")`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator
<span class="hljs-keyword">import</span> torch

accelerator = Accelerator(project_dir=<span class="hljs-string">&quot;my/save/path&quot;</span>)

my_scheduler = torch.optim.lr_scheduler.StepLR(my_optimizer, step_size=<span class="hljs-number">1</span>, gamma=<span class="hljs-number">0.99</span>)
my_model, my_optimizer, my_training_dataloader = accelerator.prepare(my_model, my_optimizer, my_training_dataloader)

<span class="hljs-comment"># Register the LR scheduler</span>
accelerator.register_for_checkpointing(my_scheduler)

<span class="hljs-comment"># Save the starting state</span>
accelerator.save_state()

device = accelerator.device
my_model.to(device)

<span class="hljs-comment"># Perform training</span>
<span class="hljs-keyword">for</span> epoch <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(num_epochs):
    <span class="hljs-keyword">for</span> batch <span class="hljs-keyword">in</span> my_training_dataloader:
        my_optimizer.zero_grad()
        inputs, targets = batch
        inputs = inputs.to(device)
        targets = targets.to(device)
        outputs = my_model(inputs)
        loss = my_loss_function(outputs, targets)
        accelerator.backward(loss)
        my_optimizer.step()
    my_scheduler.step()

<span class="hljs-comment"># Restore previous state</span>
accelerator.load_state(<span class="hljs-string">&quot;my/save/path/checkpointing/checkpoint_0&quot;</span>)`}}),{c(){g=s("meta"),M=d(),v=s("h1"),y=s("a"),q=s("span"),Xe(b.$$.fragment),te=d(),I=s("span"),ae=o("Checkpointing"),F=d(),A=s("p"),oe=o(`When training a PyTorch model with \u{1F917} Accelerate, you may often want to save and continue a state of training. Doing so requires
saving and loading the model, optimizer, RNG generators, and the GradScaler. Inside \u{1F917} Accelerate are two convenience functions to achieve this quickly:`),W=d(),k=s("ul"),E=s("li"),re=o("Use "),z=s("a"),se=o("save_state()"),ce=o(" for saving everything mentioned above to a folder location"),ne=d(),w=s("li"),ie=o("Use "),$=s("a"),le=o("load_state()"),he=o(" for loading everything stored from an earlier "),T=s("code"),pe=o("save_state"),H=d(),h=s("p"),de=o("To further customize where and how states saved through "),C=s("a"),me=o("save_state()"),_e=o(" the "),P=s("a"),ue=o("ProjectConfiguration"),fe=o(` class can be used. For example
if `),D=s("code"),ge=o("automatic_checkpoint_naming"),ve=o(" is enabled each saved checkpoint will be located then at "),O=s("code"),ye=o("Accelerator.project_dir/checkpoints/checkpoint_{checkpoint_number}"),ke=o("."),J=d(),x=s("p"),we=o("It should be noted that the expectation is that those states come from the same training script, they should not be from two separate scripts."),K=d(),S=s("ul"),p=s("li"),be=o("By using "),L=s("a"),Ee=o("register_for_checkpointing()"),je=o(`, you can register custom objects to be automatically stored or loaded from the two prior functions,
so long as the object has a `),U=s("code"),Ae=o("state_dict"),ze=d(),B=s("strong"),$e=o("and"),Ce=o(" a "),G=s("code"),Pe=o("load_state_dict"),xe=o(" functionality. This could include objects such as a learning rate scheduler."),Q=d(),R=s("p"),Se=o("Below is a brief example using checkpointing to save and reload a state during training:"),V=d(),Xe(j.$$.fragment),this.h()},l(e){const i=ct('[data-svelte="svelte-1phssyn"]',document.head);g=c(i,"META",{name:!0,content:!0}),i.forEach(a),M=m(e),v=c(e,"H1",{class:!0});var Y=n(v);y=c(Y,"A",{id:!0,class:!0,href:!0});var Re=n(y);q=c(Re,"SPAN",{});var qe=n(q);Ye(b.$$.fragment,qe),qe.forEach(a),Re.forEach(a),te=m(Y),I=c(Y,"SPAN",{});var Ie=n(I);ae=r(Ie,"Checkpointing"),Ie.forEach(a),Y.forEach(a),F=m(e),A=c(e,"P",{});var Te=n(A);oe=r(Te,`When training a PyTorch model with \u{1F917} Accelerate, you may often want to save and continue a state of training. Doing so requires
saving and loading the model, optimizer, RNG generators, and the GradScaler. Inside \u{1F917} Accelerate are two convenience functions to achieve this quickly:`),Te.forEach(a),W=m(e),k=c(e,"UL",{});var Z=n(k);E=c(Z,"LI",{});var ee=n(E);re=r(ee,"Use "),z=c(ee,"A",{href:!0});var De=n(z);se=r(De,"save_state()"),De.forEach(a),ce=r(ee," for saving everything mentioned above to a folder location"),ee.forEach(a),ne=m(Z),w=c(Z,"LI",{});var N=n(w);ie=r(N,"Use "),$=c(N,"A",{href:!0});var Oe=n($);le=r(Oe,"load_state()"),Oe.forEach(a),he=r(N," for loading everything stored from an earlier "),T=c(N,"CODE",{});var Ue=n(T);pe=r(Ue,"save_state"),Ue.forEach(a),N.forEach(a),Z.forEach(a),H=m(e),h=c(e,"P",{});var u=n(h);de=r(u,"To further customize where and how states saved through "),C=c(u,"A",{href:!0});var Be=n(C);me=r(Be,"save_state()"),Be.forEach(a),_e=r(u," the "),P=c(u,"A",{href:!0});var Ge=n(P);ue=r(Ge,"ProjectConfiguration"),Ge.forEach(a),fe=r(u,` class can be used. For example
if `),D=c(u,"CODE",{});var Ne=n(D);ge=r(Ne,"automatic_checkpoint_naming"),Ne.forEach(a),ve=r(u," is enabled each saved checkpoint will be located then at "),O=c(u,"CODE",{});var Me=n(O);ye=r(Me,"Accelerator.project_dir/checkpoints/checkpoint_{checkpoint_number}"),Me.forEach(a),ke=r(u,"."),u.forEach(a),J=m(e),x=c(e,"P",{});var Fe=n(x);we=r(Fe,"It should be noted that the expectation is that those states come from the same training script, they should not be from two separate scripts."),Fe.forEach(a),K=m(e),S=c(e,"UL",{});var We=n(S);p=c(We,"LI",{});var f=n(p);be=r(f,"By using "),L=c(f,"A",{href:!0});var He=n(L);Ee=r(He,"register_for_checkpointing()"),He.forEach(a),je=r(f,`, you can register custom objects to be automatically stored or loaded from the two prior functions,
so long as the object has a `),U=c(f,"CODE",{});var Je=n(U);Ae=r(Je,"state_dict"),Je.forEach(a),ze=m(f),B=c(f,"STRONG",{});var Ke=n(B);$e=r(Ke,"and"),Ke.forEach(a),Ce=r(f," a "),G=c(f,"CODE",{});var Qe=n(G);Pe=r(Qe,"load_state_dict"),Qe.forEach(a),xe=r(f," functionality. This could include objects such as a learning rate scheduler."),f.forEach(a),We.forEach(a),Q=m(e),R=c(e,"P",{});var Ve=n(R);Se=r(Ve,"Below is a brief example using checkpointing to save and reload a state during training:"),Ve.forEach(a),V=m(e),Ye(j.$$.fragment,e),this.h()},h(){_(g,"name","hf:doc:metadata"),_(g,"content",JSON.stringify(dt)),_(y,"id","checkpointing"),_(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),_(y,"href","#checkpointing"),_(v,"class","relative group"),_(z,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state"),_($,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state"),_(C,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state"),_(P,"href","/docs/accelerate/main/en/package_reference/utilities#accelerate.utils.ProjectConfiguration"),_(L,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.register_for_checkpointing")},m(e,i){t(document.head,g),l(e,M,i),l(e,v,i),t(v,y),t(y,q),Ze(b,q,null),t(v,te),t(v,I),t(I,ae),l(e,F,i),l(e,A,i),t(A,oe),l(e,W,i),l(e,k,i),t(k,E),t(E,re),t(E,z),t(z,se),t(E,ce),t(k,ne),t(k,w),t(w,ie),t(w,$),t($,le),t(w,he),t(w,T),t(T,pe),l(e,H,i),l(e,h,i),t(h,de),t(h,C),t(C,me),t(h,_e),t(h,P),t(P,ue),t(h,fe),t(h,D),t(D,ge),t(h,ve),t(h,O),t(O,ye),t(h,ke),l(e,J,i),l(e,x,i),t(x,we),l(e,K,i),l(e,S,i),t(S,p),t(p,be),t(p,L),t(L,Ee),t(p,je),t(p,U),t(U,Ae),t(p,ze),t(p,B),t(B,$e),t(p,Ce),t(p,G),t(G,Pe),t(p,xe),l(e,Q,i),l(e,R,i),t(R,Se),l(e,V,i),Ze(j,e,i),X=!0},p:nt,i(e){X||(et(b.$$.fragment,e),et(j.$$.fragment,e),X=!0)},o(e){tt(b.$$.fragment,e),tt(j.$$.fragment,e),X=!1},d(e){a(g),e&&a(M),e&&a(v),at(b),e&&a(F),e&&a(A),e&&a(W),e&&a(k),e&&a(H),e&&a(h),e&&a(J),e&&a(x),e&&a(K),e&&a(S),e&&a(Q),e&&a(R),e&&a(V),at(j,e)}}}const dt={local:"checkpointing",title:"Checkpointing"};function mt(Le){return it(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gt extends ot{constructor(g){super();rt(this,g,mt,pt,st,{})}}export{gt as default,dt as metadata};
