import{S as _v,i as vv,s as $v,e as a,k as l,w as $,t as s,M as bv,c as o,d as r,m as i,a as n,x as b,h as c,b as d,G as e,g as u,y,q as w,o as E,B as A,v as yv,L as Ws}from"../../chunks/vendor-hf-doc-builder.js";import{T as Zt}from"../../chunks/Tip-hf-doc-builder.js";import{D as P}from"../../chunks/Docstring-hf-doc-builder.js";import{C as L}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as V}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Rs}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function wv(D){let h,x;return{c(){h=a("p"),x=s("Step three is optional, but considered a best practice.")},l(v){h=o(v,"P",{});var g=n(h);x=c(g,"Step three is optional, but considered a best practice."),g.forEach(r)},m(v,g){u(v,h,g),e(h,x)},d(v){v&&r(h)}}}function Ev(D){let h,x;return{c(){h=a("p"),x=s("Step five is mandatory when using distributed evaluation")},l(v){h=o(v,"P",{});var g=n(h);x=c(g,"Step five is mandatory when using distributed evaluation"),g.forEach(r)},m(v,g){u(v,h,g),e(h,x)},d(v){v&&r(h)}}}function Av(D){let h,x,v,g,j;return g=new L({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

with accelerator.accumulate():
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.accumulate():
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        scheduler.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){h=a("p"),x=s("Example:"),v=l(),$(g.$$.fragment)},l(m){h=o(m,"P",{});var k=n(h);x=c(k,"Example:"),k.forEach(r),v=i(m),b(g.$$.fragment,m)},m(m,k){u(m,h,k),e(h,x),u(m,v,k),y(g,m,k),j=!0},p:Ws,i(m){j||(w(g.$$.fragment,m),j=!0)},o(m){E(g.$$.fragment,m),j=!1},d(m){m&&r(h),m&&r(v),A(g,m)}}}function kv(D){let h,x,v,g,j;return g=new L({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for (input, target) in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> (<span class="hljs-built_in">input</span>, target) <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){h=a("p"),x=s("Example:"),v=l(),$(g.$$.fragment)},l(m){h=o(m,"P",{});var k=n(h);x=c(k,"Example:"),k.forEach(r),v=i(m),b(g.$$.fragment,m)},m(m,k){u(m,h,k),e(h,x),u(m,v,k),y(g,m,k),j=!0},p:Ws,i(m){j||(w(g.$$.fragment,m),j=!0)},o(m){E(g.$$.fragment,m),j=!1},d(m){m&&r(h),m&&r(v),A(g,m)}}}function xv(D){let h,x,v,g,j;return g=new L({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for (input, target) in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_value_(model.parameters(), clip_value)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> (<span class="hljs-built_in">input</span>, target) <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_value_(model.parameters(), clip_value)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){h=a("p"),x=s("Example:"),v=l(),$(g.$$.fragment)},l(m){h=o(m,"P",{});var k=n(h);x=c(k,"Example:"),k.forEach(r),v=i(m),b(g.$$.fragment,m)},m(m,k){u(m,h,k),e(h,x),u(m,v,k),y(g,m,k),j=!0},p:Ws,i(m){j||(w(g.$$.fragment,m),j=!0)},o(m){E(g.$$.fragment,m),j=!1},d(m){m&&r(h),m&&r(v),A(g,m)}}}function jv(D){let h,x,v,g;return{c(){h=a("p"),x=a("code"),v=s("join_uneven_inputs"),g=s(` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`)},l(j){h=o(j,"P",{});var m=n(h);x=o(m,"CODE",{});var k=n(x);v=c(k,"join_uneven_inputs"),k.forEach(r),g=c(m,` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`),m.forEach(r)},m(j,m){u(j,h,m),e(h,x),e(x,v),e(h,g)},d(j){j&&r(h)}}}function Pv(D){let h,x,v,g,j;return{c(){h=a("p"),x=s("Overidding "),v=a("code"),g=s("even_batches"),j=s(" will not affect iterable-style data loaders.")},l(m){h=o(m,"P",{});var k=n(h);x=c(k,"Overidding "),v=o(k,"CODE",{});var S=n(v);g=c(S,"even_batches"),S.forEach(r),j=c(k," will not affect iterable-style data loaders."),k.forEach(r)},m(m,k){u(m,h,k),e(h,x),e(h,v),e(v,g),e(h,j)},d(m){m&&r(h)}}}function Dv(D){let h,x,v,g,j;return g=new L({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(even_batches=True)
ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

with accelerator.join_uneven_inputs([ddp_model], even_batches=False):
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(even_batches=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.join_uneven_inputs([ddp_model], even_batches=<span class="hljs-literal">False</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){h=a("p"),x=s("Example:"),v=l(),$(g.$$.fragment)},l(m){h=o(m,"P",{});var k=n(h);x=c(k,"Example:"),k.forEach(r),v=i(m),b(g.$$.fragment,m)},m(m,k){u(m,h,k),e(h,x),u(m,v,k),y(g,m,k),j=!0},p:Ws,i(m){j||(w(g.$$.fragment,m),j=!0)},o(m){E(g.$$.fragment,m),j=!1},d(m){m&&r(h),m&&r(v),A(g,m)}}}function Tv(D){let h,x,v,g,j;return{c(){h=a("p"),x=s("Should only be used in conjunction with "),v=a("a"),g=s("Accelerator.save_state()"),j=s("."),this.h()},l(m){h=o(m,"P",{});var k=n(h);x=c(k,"Should only be used in conjunction with "),v=o(k,"A",{href:!0});var S=n(v);g=c(S,"Accelerator.save_state()"),S.forEach(r),j=c(k,"."),k.forEach(r),this.h()},h(){d(v,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state")},m(m,k){u(m,h,k),e(h,x),e(h,v),e(v,g),e(h,j)},d(m){m&&r(h)}}}function zv(D){let h,x,v,g,j;return g=new L({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
input_a = next(iter(dataloader))
input_b = next(iter(dataloader))

with accelerator.no_sync():
    outputs = model(input_a)
    loss = loss_func(outputs)
    accelerator.backward(loss)
    # No synchronization across processes, only accumulate gradients
outputs = model(input_b)
accelerator.backward(loss)
# Synchronization across all processes
optimizer.step()
optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_a = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>input_b = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.no_sync():
<span class="hljs-meta">... </span>    outputs = model(input_a)
<span class="hljs-meta">... </span>    loss = loss_func(outputs)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-comment"># No synchronization across processes, only accumulate gradients</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_b)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Synchronization across all processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.step()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.zero_grad()`}}),{c(){h=a("p"),x=s("Example:"),v=l(),$(g.$$.fragment)},l(m){h=o(m,"P",{});var k=n(h);x=c(k,"Example:"),k.forEach(r),v=i(m),b(g.$$.fragment,m)},m(m,k){u(m,h,k),e(h,x),u(m,v,k),y(g,m,k),j=!0},p:Ws,i(m){j||(w(g.$$.fragment,m),j=!0)},o(m){E(g.$$.fragment,m),j=!1},d(m){m&&r(h),m&&r(v),A(g,m)}}}function Ov(D){let h,x;return{c(){h=a("p"),x=s("You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision")},l(v){h=o(v,"P",{});var g=n(h);x=c(g,"You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision"),g.forEach(r)},m(v,g){u(v,h,g),e(h,x)},d(v){v&&r(h)}}}function Iv(D){let h,x,v,g,j,m,k,S,ce,ze,M;return{c(){h=a("p"),x=s("Every "),v=a("code"),g=s("object"),j=s(" must have a "),m=a("code"),k=s("load_state_dict"),S=s(" and "),ce=a("code"),ze=s("state_dict"),M=s(" function to be stored.")},l(le){h=o(le,"P",{});var O=n(h);x=c(O,"Every "),v=o(O,"CODE",{});var za=n(v);g=c(za,"object"),za.forEach(r),j=c(O," must have a "),m=o(O,"CODE",{});var Oa=n(m);k=c(Oa,"load_state_dict"),Oa.forEach(r),S=c(O," and "),ce=o(O,"CODE",{});var er=n(ce);ze=c(er,"state_dict"),er.forEach(r),M=c(O," function to be stored."),O.forEach(r)},m(le,O){u(le,h,O),e(h,x),e(h,v),e(v,g),e(h,j),e(h,m),e(m,k),e(h,S),e(h,ce),e(ce,ze),e(h,M)},d(le){le&&r(h)}}}function Sv(D){let h,x;return{c(){h=a("p"),x=s(`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`)},l(v){h=o(v,"P",{});var g=n(h);x=c(g,`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`),g.forEach(r)},m(v,g){u(v,h,g),e(h,x)},d(v){v&&r(h)}}}function Lv(D){let h,x,v,g,j,m,k,S,ce,ze,M,le,O,za,Oa,er,ie,Oe,go,tr,Rl,_o,Wl,Fs,Ia,Fl,Hs,Y,de,Hl,Sa,Yl,Bl,vo,Jl,Kl,Ql,rr,Xl,La,Zl,ei,ti,W,ri,$o,ai,oi,bo,ni,si,yo,ci,li,Ys,Ie,Bs,pe,Se,ii,wo,di,pi,Eo,hi,mi,Na,ui,Ca,fi,Js,Le,Ks,Ne,gi,Ao,_i,vi,Qs,he,Ce,ko,ar,$i,xo,bi,Xs,me,qe,jo,or,yi,Po,wi,Zs,ue,Do,Ei,Ai,qa,ki,xi,ec,nr,tc,fe,Ue,To,sr,ji,zo,Pi,rc,ge,Ve,Oo,cr,Di,Io,Ti,ac,Me,zi,So,Oi,Ii,oc,lr,nc,Ge,Si,Ua,Li,Ni,sc,ir,cc,_e,Re,Lo,dr,Ci,No,qi,lc,We,Ui,Co,Vi,Mi,ic,pr,dc,Fe,Gi,Va,Ri,Wi,pc,hr,hc,ve,He,qo,mr,Fi,Uo,Hi,mc,Ma,Yi,uc,ur,fc,fr,gc,$e,Ye,Vo,gr,Bi,Mo,Ji,_c,Be,Ki,Ga,Qi,Xi,vc,be,Je,Go,_r,Zi,Ro,ed,$c,Ke,td,Ra,rd,ad,bc,vr,yc,B,od,Wa,nd,sd,Wo,cd,ld,wc,$r,Ec,ye,Qe,Fo,br,id,Ho,dd,Ac,U,pd,Xe,hd,Yo,md,ud,fd,Bo,gd,_d,Ze,vd,Jo,$d,bd,yd,Ko,wd,kc,we,et,Qo,yr,Ed,Xo,Ad,xc,tt,kd,Fa,xd,jd,jc,wr,Pc,Ee,rt,Zo,Er,Pd,en,Dd,Dc,f,Ar,Td,tn,zd,Od,rn,an,Id,Sd,T,at,on,Ld,Nd,nn,Cd,qd,Ud,ot,sn,Vd,Md,Ha,Gd,Rd,Wd,nt,cn,Fd,Hd,ln,Yd,Bd,Jd,st,dn,Kd,Qd,pn,Xd,Zd,ep,ct,hn,tp,rp,mn,ap,op,np,lt,un,sp,cp,fn,lp,ip,dp,it,gn,pp,hp,_n,mp,up,fp,dt,vn,gp,_p,Ya,vp,$p,bp,pt,$n,yp,wp,bn,Ep,Ap,kp,ht,yn,xp,jp,wn,Pp,Dp,Tp,J,kr,zp,En,Op,Ip,mt,Sp,ut,xr,Lp,An,Np,Cp,K,jr,qp,Ae,Up,kn,Vp,Mp,xn,Gp,Rp,Wp,Pr,Fp,jn,Hp,Yp,Bp,ft,Dr,Jp,Tr,Kp,Pn,Qp,Xp,Zp,Q,zr,eh,Or,th,Dn,rh,ah,oh,gt,nh,X,Ir,sh,Sr,ch,Tn,lh,ih,dh,_t,ph,vt,Lr,hh,zn,mh,uh,$t,Nr,fh,On,gh,_h,Z,Cr,vh,qr,$h,In,bh,yh,wh,Sn,Eh,Ah,bt,Ur,kh,Vr,xh,Ln,jh,Ph,Dh,yt,Mr,Th,Gr,zh,Ba,Oh,Ih,Sh,wt,Rr,Lh,F,Nh,Nn,Ch,qh,Cn,Uh,Vh,qn,Mh,Gh,Rh,Et,Wr,Wh,Fr,Fh,Un,Hh,Yh,Bh,N,Hr,Jh,Yr,Kh,Vn,Qh,Xh,Zh,At,em,kt,tm,xt,rm,ee,Br,am,Mn,om,nm,jt,sm,te,Jr,cm,Gn,lm,im,Rn,dm,pm,Pt,Kr,hm,ke,mm,Wn,um,fm,Fn,gm,_m,vm,re,Qr,$m,Hn,bm,ym,Yn,wm,Em,G,Xr,Am,Zr,km,Bn,xm,jm,Pm,ea,Dm,Jn,Tm,zm,Om,Dt,Im,Tt,ta,Sm,Kn,Lm,Nm,zt,ra,Cm,Qn,qm,Um,Ot,aa,Vm,Xn,Mm,Gm,It,oa,Rm,Zn,Wm,Fm,St,na,Hm,es,Ym,Bm,Lt,sa,Jm,ts,Km,Qm,ae,ca,Xm,la,Zm,rs,eu,tu,ru,Nt,au,Ct,ia,ou,da,nu,Ja,su,cu,lu,qt,pa,iu,ha,du,Ka,pu,hu,mu,Ut,ma,uu,ua,fu,Qa,gu,_u,vu,Vt,fa,$u,ga,bu,Xa,yu,wu,Eu,Mt,_a,Au,va,ku,as,xu,ju,Pu,oe,$a,Du,xe,Tu,os,zu,Ou,ns,Iu,Su,Lu,ss,Nu,Cu,R,ba,qu,H,Uu,cs,Vu,Mu,ls,Gu,Ru,is,Wu,Fu,Hu,ds,Yu,Bu,Gt,Ju,Rt,ya,Ku,wa,Qu,ps,Xu,Zu,ef,C,Ea,tf,hs,rf,af,I,of,ms,nf,sf,us,cf,lf,fs,df,pf,gs,hf,mf,_s,uf,ff,vs,gf,_f,vf,Aa,$f,$s,bf,yf,wf,Wt,Ef,Ft,ka,Af,bs,kf,xf,Ht,xa,jf,je,Pf,ys,Df,Tf,Za,zf,Of,If,Yt,ja,Sf,ws,Lf,Tc;return m=new V({}),tr=new V({}),Ie=new Zt({props:{$$slots:{default:[wv]},$$scope:{ctx:D}}}),Le=new Zt({props:{warning:!0,$$slots:{default:[Ev]},$$scope:{ctx:D}}}),ar=new V({}),or=new V({}),nr=new L({props:{code:`- print("My thing I want to print!")
+ accelerator.print("My thing I want to print!")`,highlighted:`<span class="hljs-deletion">- print(&quot;My thing I want to print!&quot;)</span>
<span class="hljs-addition">+ accelerator.print(&quot;My thing I want to print!&quot;)</span>`}}),sr=new V({}),cr=new V({}),lr=new L({props:{code:`if accelerator.is_local_main_process:
    do_thing_once_per_server()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_local_main_process:
    do_thing_once_per_server()`}}),ir=new L({props:{code:`@accelerator.on_local_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once_per_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once_per_server()`}}),dr=new V({}),pr=new L({props:{code:`if accelerator.is_main_process:
    do_thing_once()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_main_process:
    do_thing_once()`}}),hr=new L({props:{code:`@accelerator.on_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once()`,highlighted:`<span class="hljs-meta">@accelerator.on_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once()`}}),mr=new V({}),ur=new L({props:{code:`@accelerator.on_local_process(local_process_idx=0)
def do_my_thing():
    "Something done on process index 0 on each server"
    do_thing_on_index_zero_on_each_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_idx=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0 on each server&quot;</span>
    do_thing_on_index_zero_on_each_server()`}}),fr=new L({props:{code:`@accelerator.on_process(process_index=0)
def do_my_thing():
    "Something done on process index 0"
    do_thing_on_index_zero()`,highlighted:`<span class="hljs-meta">@accelerator.on_process(<span class="hljs-params">process_index=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0&quot;</span>
    do_thing_on_index_zero()`}}),gr=new V({}),_r=new V({}),vr=new L({props:{code:`model = MyModel()
model = accelerator.prepare(model)
# Unwrap
model = accelerator.unwrap_model(model)`,highlighted:`model = MyModel()
model = accelerator.prepare(model)
<span class="hljs-comment"># Unwrap</span>
model = accelerator.unwrap_model(model)`}}),$r=new L({props:{code:`  state_dict = model.state_dict()
- torch.save(state_dict, "my_state.pkl")
+ accelerator.save(state_dict, "my_state.pkl")`,highlighted:`  state_dict = model.state_dict()
<span class="hljs-deletion">- torch.save(state_dict, &quot;my_state.pkl&quot;)</span>
<span class="hljs-addition">+ accelerator.save(state_dict, &quot;my_state.pkl&quot;)</span>`}}),br=new V({}),yr=new V({}),wr=new L({props:{code:`- accelerator = Accelerator()
+ accelerator = Accelerator(gradient_accumulation_steps=2)

  for (input, label) in training_dataloader:
+     with accelerator.accumulate(model):
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`,highlighted:`<span class="hljs-deletion">- accelerator = Accelerator()</span>
<span class="hljs-addition">+ accelerator = Accelerator(gradient_accumulation_steps=2)</span>

  for (input, label) in training_dataloader:
<span class="hljs-addition">+     with accelerator.accumulate(model):</span>
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`}}),Er=new V({}),Ar=new P({props:{name:"class accelerate.Accelerator",anchor:"accelerate.Accelerator",parameters:[{name:"device_placement",val:": bool = True"},{name:"split_batches",val:": bool = False"},{name:"mixed_precision",val:": typing.Union[accelerate.utils.dataclasses.PrecisionType, str] = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"cpu",val:": bool = False"},{name:"deepspeed_plugin",val:": DeepSpeedPlugin = None"},{name:"fsdp_plugin",val:": FullyShardedDataParallelPlugin = None"},{name:"megatron_lm_plugin",val:": MegatronLMPlugin = None"},{name:"rng_types",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.RNGType]], NoneType] = None"},{name:"log_with",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.LoggerType, accelerate.tracking.GeneralTracker]], NoneType] = None"},{name:"project_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"project_config",val:": typing.Optional[accelerate.utils.dataclasses.ProjectConfiguration] = None"},{name:"logging_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"dispatch_batches",val:": typing.Optional[bool] = None"},{name:"even_batches",val:": bool = True"},{name:"step_scheduler_with_optimizer",val:": bool = True"},{name:"kwargs_handlers",val:": typing.Optional[typing.List[accelerate.utils.dataclasses.KwargsHandler]] = None"},{name:"dynamo_backend",val:": typing.Union[accelerate.utils.dataclasses.DynamoBackend, str] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the accelerator should put objects on device (tensors yielded by the dataloader, model,
etc&#x2026;).`,name:"device_placement"},{anchor:"accelerate.Accelerator.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the accelerator should split the batches yielded by the dataloaders across the devices. If
<code>True</code> the actual batch size used will be the same on any kind of distributed processes, but it must be a
round multiple of the <code>num_processes</code> you are using. If <code>False</code>, actual batch size used will be the one set
in your script multiplied by the number of processes.`,name:"split_batches"},{anchor:"accelerate.Accelerator.mixed_precision",description:`<strong>mixed_precision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Whether or not to use mixed precision training (fp16 or bfloat16). Choose from &#x2018;no&#x2019;,&#x2018;fp16&#x2019;,&#x2018;bf16&#x2019;. Will
default to the value in the environment variable <code>ACCELERATE_MIXED_PRECISION</code>, which will use the default
value in the accelerate config of the current system or the flag passed with the <code>accelerate.launch</code>
command. &#x2018;fp16&#x2019; requires pytorch 1.6 or higher. &#x2018;bf16&#x2019; requires pytorch 1.10 or higher.`,name:"mixed_precision"},{anchor:"accelerate.Accelerator.gradient_accumulation_steps",description:`<strong>gradient_accumulation_steps</strong> (<code>int</code>, <em>optional</em>, default to 1) &#x2014;
The number of steps that should pass before gradients are accumulated. A number &gt; 1 should be combined with
<code>Accelerator.accumulate</code>.`,name:"gradient_accumulation_steps"},{anchor:"accelerate.Accelerator.cpu",description:`<strong>cpu</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to force the script to execute on CPU. Will ignore GPU available if set to <code>True</code> and force
the execution on one process only.`,name:"cpu"},{anchor:"accelerate.Accelerator.deepspeed_plugin",description:`<strong>deepspeed_plugin</strong> (<code>DeepSpeedPlugin</code>, <em>optional</em>) &#x2014;
Tweak your DeepSpeed related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"deepspeed_plugin"},{anchor:"accelerate.Accelerator.fsdp_plugin",description:`<strong>fsdp_plugin</strong> (<code>FullyShardedDataParallelPlugin</code>, <em>optional</em>) &#x2014;
Tweak your FSDP related args using this argument. This argument is optional and can be configured directly
using <em>accelerate config</em>`,name:"fsdp_plugin"},{anchor:"accelerate.Accelerator.megatron_lm_plugin",description:`<strong>megatron_lm_plugin</strong> (<code>MegatronLMPlugin</code>, <em>optional</em>) &#x2014;
Tweak your MegatronLM related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"megatron_lm_plugin"},{anchor:"accelerate.Accelerator.rng_types",description:`<strong>rng_types</strong> (list of <code>str</code> or <code>RNGType</code>) &#x2014;
The list of random number generators to synchronize at the beginning of each iteration in your prepared
dataloaders. Should be one or several of:</p>
<ul>
<li><code>&quot;torch&quot;</code>: the base torch random number generator</li>
<li><code>&quot;cuda&quot;</code>: the CUDA random number generator (GPU only)</li>
<li><code>&quot;xla&quot;</code>: the XLA random number generator (TPU only)</li>
<li><code>&quot;generator&quot;</code>: the <code>torch.Generator</code> of the sampler (or batch sampler if there is no sampler in your
dataloader) or of the iterable dataset (if it exists) if the underlying dataset is of that type.</li>
</ul>
<p>Will default to <code>[&quot;torch&quot;]</code> for PyTorch versions &lt;=1.5.1 and <code>[&quot;generator&quot;]</code> for PyTorch versions &gt;= 1.6.`,name:"rng_types"},{anchor:"accelerate.Accelerator.log_with",description:`<strong>log_with</strong> (list of <code>str</code>, <a href="/docs/accelerate/main/en/package_reference/utilities#accelerate.utils.LoggerType">LoggerType</a> or <a href="/docs/accelerate/main/en/package_reference/tracking#accelerate.tracking.GeneralTracker">GeneralTracker</a>, <em>optional</em>) &#x2014;
A list of loggers to be setup for experiment tracking. Should be one or several of:</p>
<ul>
<li><code>&quot;all&quot;</code></li>
<li><code>&quot;tensorboard&quot;</code></li>
<li><code>&quot;wandb&quot;</code></li>
<li><code>&quot;comet_ml&quot;</code>
If <code>&quot;all&quot;</code> is selected, will pick up all available trackers in the environment and initialize them. Can
also accept implementations of <code>GeneralTracker</code> for custom trackers, and can be combined with <code>&quot;all&quot;</code>.</li>
</ul>`,name:"log_with"},{anchor:"accelerate.Accelerator.project_config",description:`<strong>project_config</strong> (<code>ProjectConfiguration</code>, <em>optional</em>) &#x2014;
A configuration for how saving the state can be handled.`,name:"project_config"},{anchor:"accelerate.Accelerator.project_dir",description:`<strong>project_dir</strong> (<code>str</code>, <code>os.PathLike</code>, <em>optional</em>) &#x2014;
A path to a directory for storing data such as logs of locally-compatible loggers and potentially saved
checkpoints.`,name:"project_dir"},{anchor:"accelerate.Accelerator.dispatch_batches",description:`<strong>dispatch_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, the dataloader prepared by the Accelerator is only iterated through on the main process
and then the batches are split and broadcast to each process. Will default to <code>True</code> for <code>DataLoader</code> whose
underlying dataset is an <code>IterableDataset</code>, <code>False</code> otherwise.`,name:"dispatch_batches"},{anchor:"accelerate.Accelerator.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, in cases where the total batch size across all processes does not exactly divide the
dataset, samples at the start of the dataset will be duplicated so the batch can be divided equally among
all workers.`,name:"even_batches"},{anchor:"accelerate.Accelerator.step_scheduler_with_optimizer",description:"<strong>step_scheduler_with_optimizer</strong> (<code>bool</code>, *optional<code>, defaults to </code>True<code>) -- Set </code>True<code>if the learning rate scheduler is stepped at the same time as the optimizer,</code>False` if only\ndone under certain circumstances (at the end of each epoch, for instance).",name:"step_scheduler_with_optimizer"},{anchor:"accelerate.Accelerator.kwargs_handlers",description:`<strong>kwargs_handlers</strong> (<code>List[KwargHandler]</code>, <em>optional</em>) &#x2014;
A list of <code>KwargHandler</code> to customize how the objects related to distributed training or mixed precision
are created. See <a href="kwargs">kwargs</a> for more information.`,name:"kwargs_handlers"},{anchor:"accelerate.Accelerator.dynamo_backend",description:`<strong>dynamo_backend</strong> (<code>str</code> or <code>DynamoBackend</code>, <em>optional</em>, defaults to <code>&quot;no&quot;</code>) &#x2014;
Set to one of the possible dynamo backends to optimize your training with torch dynamo.`,name:"dynamo_backend"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L109"}}),kr=new P({props:{name:"accumulate",anchor:"accelerate.Accelerator.accumulate",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.accumulate.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L625"}}),mt=new Rs({props:{anchor:"accelerate.Accelerator.accumulate.example",$$slots:{default:[Av]},$$scope:{ctx:D}}}),xr=new P({props:{name:"autocast",anchor:"accelerate.Accelerator.autocast",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1883"}}),jr=new P({props:{name:"backward",anchor:"accelerate.Accelerator.backward",parameters:[{name:"loss",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1318"}}),Dr=new P({props:{name:"clear",anchor:"accelerate.Accelerator.clear",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1791"}}),zr=new P({props:{name:"clip_grad_norm_",anchor:"accelerate.Accelerator.clip_grad_norm_",parameters:[{name:"parameters",val:""},{name:"max_norm",val:""},{name:"norm_type",val:" = 2"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1357",returnDescription:`
<p>Total norm of the parameter gradients (viewed as a single vector).</p>
`,returnType:`
<p><code>torch.Tensor</code></p>
`}}),gt=new Rs({props:{anchor:"accelerate.Accelerator.clip_grad_norm_.example",$$slots:{default:[kv]},$$scope:{ctx:D}}}),Ir=new P({props:{name:"clip_grad_value_",anchor:"accelerate.Accelerator.clip_grad_value_",parameters:[{name:"parameters",val:""},{name:"clip_value",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1395"}}),_t=new Rs({props:{anchor:"accelerate.Accelerator.clip_grad_value_.example",$$slots:{default:[xv]},$$scope:{ctx:D}}}),Lr=new P({props:{name:"end_training",anchor:"accelerate.Accelerator.end_training",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1596"}}),Nr=new P({props:{name:"free_memory",anchor:"accelerate.Accelerator.free_memory",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1778"}}),Cr=new P({props:{name:"gather",anchor:"accelerate.Accelerator.gather",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to gather across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1422",returnDescription:`
<p>The gathered tensor(s). Note that the
first dimension of the result is <em>num_processes</em> multiplied by the first dimension of the input tensors.</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),Ur=new P({props:{name:"gather_for_metrics",anchor:"accelerate.Accelerator.gather_for_metrics",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather_for_metrics.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors for calculating metrics across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1440"}}),Mr=new P({props:{name:"get_state_dict",anchor:"accelerate.Accelerator.get_state_dict",parameters:[{name:"model",val:""},{name:"unwrap",val:" = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_state_dict.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model sent through <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare">Accelerator.prepare()</a>`,name:"model"},{anchor:"accelerate.Accelerator.get_state_dict.unwrap",description:`<strong>unwrap</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to return the original underlying state_dict of <code>model</code> or to return the wrapped state_dict`,name:"unwrap"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1823"}}),Rr=new P({props:{name:"get_tracker",anchor:"accelerate.Accelerator.get_tracker",parameters:[{name:"name",val:": str"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_tracker.name",description:`<strong>name</strong> (<code>str</code>) &#x2014;
The name of a tracker, corresponding to the <code>.name</code> property.`,name:"name"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1562"}}),Wr=new P({props:{name:"init_trackers",anchor:"accelerate.Accelerator.init_trackers",parameters:[{name:"project_name",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"init_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.init_trackers.project_name",description:`<strong>project_name</strong> (<code>str</code>) &#x2014;
The name of the project. All trackers will save their data based on this`,name:"project_name"},{anchor:"accelerate.Accelerator.init_trackers.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Optional starting configuration to be logged.`,name:"config"},{anchor:"accelerate.Accelerator.init_trackers.init_kwargs",description:`<strong>init_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>__init__</code> function. Should be
formatted like so:`,name:"init_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1527"}}),Hr=new P({props:{name:"join_uneven_inputs",anchor:"accelerate.Accelerator.join_uneven_inputs",parameters:[{name:"joinables",val:""},{name:"even_batches",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.join_uneven_inputs.joinables",description:`<strong>joinables</strong> (<code>List[torch.distributed.algorithms.Joinable]</code>) &#x2014;
A list of models or optimizers that subclass <code>torch.distributed.algorithms.Joinable</code>. Most commonly, a
PyTorch Module that was prepared with <code>Accelerator.prepare</code> for DistributedDataParallel training.`,name:"joinables"},{anchor:"accelerate.Accelerator.join_uneven_inputs.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set, this will override the value of <code>even_batches</code> set in the <code>Accelerator</code>. If it is not provided,
the default <code>Accelerator</code> value wil be used.`,name:"even_batches"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L661"}}),At=new Zt({props:{warning:!0,$$slots:{default:[jv]},$$scope:{ctx:D}}}),kt=new Zt({props:{warning:!0,$$slots:{default:[Pv]},$$scope:{ctx:D}}}),xt=new Rs({props:{anchor:"accelerate.Accelerator.join_uneven_inputs.example",$$slots:{default:[Dv]},$$scope:{ctx:D}}}),Br=new P({props:{name:"load_state",anchor:"accelerate.Accelerator.load_state",parameters:[{name:"input_dir",val:": str"}],parametersDescription:[{anchor:"accelerate.Accelerator.load_state.input_dir",description:`<strong>input_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder all relevant weights and states were saved in.`,name:"input_dir"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1707"}}),jt=new Zt({props:{$$slots:{default:[Tv]},$$scope:{ctx:D}}}),Jr=new P({props:{name:"local_main_process_first",anchor:"accelerate.Accelerator.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L562"}}),Kr=new P({props:{name:"log",anchor:"accelerate.Accelerator.log",parameters:[{name:"values",val:": dict"},{name:"step",val:": typing.Optional[int] = None"},{name:"log_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.log.values",description:`<strong>values</strong> (<code>dict</code>) &#x2014;
Values should be a dictionary-like object containing only types <code>int</code>, <code>float</code>, or <code>str</code>.`,name:"values"},{anchor:"accelerate.Accelerator.log.step",description:`<strong>step</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The run step. If included, the log will be affiliated with this step.`,name:"step"},{anchor:"accelerate.Accelerator.log.log_kwargs",description:`<strong>log_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>log</code> function. Should be formatted
like so:`,name:"log_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1576"}}),Qr=new P({props:{name:"main_process_first",anchor:"accelerate.Accelerator.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L553"}}),Xr=new P({props:{name:"no_sync",anchor:"accelerate.Accelerator.no_sync",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.no_sync.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L571"}}),Dt=new Rs({props:{anchor:"accelerate.Accelerator.no_sync.example",$$slots:{default:[zv]},$$scope:{ctx:D}}}),ta=new P({props:{name:"on_last_process",anchor:"accelerate.Accelerator.on_last_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L502"}}),ra=new P({props:{name:"on_local_main_process",anchor:"accelerate.Accelerator.on_local_main_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L490"}}),aa=new P({props:{name:"on_local_process",anchor:"accelerate.Accelerator.on_local_process",parameters:[{name:"local_process_idx",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L529"}}),oa=new P({props:{name:"on_main_process",anchor:"accelerate.Accelerator.on_main_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L478"}}),na=new P({props:{name:"on_process",anchor:"accelerate.Accelerator.on_process",parameters:[{name:"process_idx",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L514"}}),sa=new P({props:{name:"pad_across_processes",anchor:"accelerate.Accelerator.pad_across_processes",parameters:[{name:"tensor",val:""},{name:"dim",val:" = 0"},{name:"pad_index",val:" = 0"},{name:"pad_first",val:" = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.pad_across_processes.tensor",description:`<strong>tensor</strong> (nested list/tuple/dictionary of <code>torch.Tensor</code>) &#x2014;
The data to gather.`,name:"tensor"},{anchor:"accelerate.Accelerator.pad_across_processes.dim",description:`<strong>dim</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The dimension on which to pad.`,name:"dim"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_index",description:`<strong>pad_index</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The value with which to pad.`,name:"pad_index"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_first",description:`<strong>pad_first</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to pad at the beginning or the end.`,name:"pad_first"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1490"}}),ca=new P({props:{name:"prepare",anchor:"accelerate.Accelerator.prepare",parameters:[{name:"*args",val:""},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare.*args",description:`<strong>*args</strong> (list of objects) &#x2014;
Any of the following type of objects:</p>
<ul>
<li><code>torch.utils.data.DataLoader</code>: PyTorch Dataloader</li>
<li><code>torch.nn.Module</code>: PyTorch Module</li>
<li><code>torch.optim.Optimizer</code>: PyTorch Optimizer</li>
<li><code>torch.optim.lr_scheduler.LRScheduler</code>: PyTorch LR Scheduler</li>
</ul>`,name:"*args"},{anchor:"accelerate.Accelerator.prepare.device_placement",description:`<strong>device_placement</strong> (<code>List[bool]</code>, <em>optional</em>) &#x2014;
Used to customize whether automatic device placement should be performed for each object passed. Needs
to be a list of the same length as <code>args</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L818"}}),Nt=new Zt({props:{$$slots:{default:[Ov]},$$scope:{ctx:D}}}),ia=new P({props:{name:"prepare_data_loader",anchor:"accelerate.Accelerator.prepare_data_loader",parameters:[{name:"data_loader",val:": DataLoader"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_data_loader.data_loader",description:`<strong>data_loader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014;
A vanilla PyTorch DataLoader to prepare`,name:"data_loader"},{anchor:"accelerate.Accelerator.prepare_data_loader.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the batches on the proper device in the prepared dataloader. Will default to
<code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1249"}}),pa=new P({props:{name:"prepare_model",anchor:"accelerate.Accelerator.prepare_model",parameters:[{name:"model",val:": Module"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model to prepare. You don&#x2019;t need to prepare a model if it is used only for inference without
any kind of mixed precision`,name:"model"},{anchor:"accelerate.Accelerator.prepare_model.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the model on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L916"}}),ma=new P({props:{name:"prepare_optimizer",anchor:"accelerate.Accelerator.prepare_optimizer",parameters:[{name:"optimizer",val:": Optimizer"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_optimizer.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code>) &#x2014;
A vanilla PyTorch optimizer to prepare`,name:"optimizer"},{anchor:"accelerate.Accelerator.prepare_optimizer.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the optimizer on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1277"}}),fa=new P({props:{name:"prepare_scheduler",anchor:"accelerate.Accelerator.prepare_scheduler",parameters:[{name:"scheduler",val:": _LRScheduler"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_scheduler.scheduler",description:`<strong>scheduler</strong> (<code>torch.optim.lr_scheduler.LRScheduler</code>) &#x2014;
A vanilla PyTorch scheduler to prepare`,name:"scheduler"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1294"}}),_a=new P({props:{name:"print",anchor:"accelerate.Accelerator.print",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L748"}}),$a=new P({props:{name:"reduce",anchor:"accelerate.Accelerator.reduce",parameters:[{name:"tensor",val:""},{name:"reduction",val:" = 'sum'"}],parametersDescription:[{anchor:"accelerate.Accelerator.reduce.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to reduce across all processes.`,name:"tensor"},{anchor:"accelerate.Accelerator.reduce.reduction",description:`<strong>reduction</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;sum&#x201D;) &#x2014;
A reduction type, can be one of &#x2018;sum&#x2019;, &#x2018;mean&#x2019;, or &#x2018;none&#x2019;. If &#x2018;none&#x2019;, will not perform any operation.`,name:"reduction"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1472",returnDescription:`
<p>The reduced tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),ba=new P({props:{name:"register_for_checkpointing",anchor:"accelerate.Accelerator.register_for_checkpointing",parameters:[{name:"*objects",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1859"}}),Gt=new Zt({props:{$$slots:{default:[Iv]},$$scope:{ctx:D}}}),ya=new P({props:{name:"save",anchor:"accelerate.Accelerator.save",parameters:[{name:"obj",val:""},{name:"f",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save.f",description:`<strong>f</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Where to save the content of <code>obj</code>.`,name:"f"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1605"}}),Ea=new P({props:{name:"save_state",anchor:"accelerate.Accelerator.save_state",parameters:[{name:"output_dir",val:": str = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.save_state.output_dir",description:`<strong>output_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder to save all relevant weights and states.`,name:"output_dir"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1616"}}),Wt=new Zt({props:{$$slots:{default:[Sv]},$$scope:{ctx:D}}}),ka=new P({props:{name:"unscale_gradients",anchor:"accelerate.Accelerator.unscale_gradients",parameters:[{name:"optimizer",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.unscale_gradients.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code> or <code>List[torch.optim.Optimizer]</code>, <em>optional</em>) &#x2014;
The optimizer(s) for which to unscale gradients. If not set, will unscale gradients on all optimizers
that were passed to <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>.`,name:"optimizer"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1337"}}),xa=new P({props:{name:"unwrap_model",anchor:"accelerate.Accelerator.unwrap_model",parameters:[{name:"model",val:""},{name:"keep_fp32_wrapper",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.unwrap_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to unwrap.`,name:"model"},{anchor:"accelerate.Accelerator.unwrap_model.keep_fp32_wrapper",description:`<strong>keep_fp32_wrapper</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to not remove the mixed precision hook if it was added.`,name:"keep_fp32_wrapper"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1507"}}),ja=new P({props:{name:"wait_for_everyone",anchor:"accelerate.Accelerator.wait_for_everyone",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1520"}}),{c(){h=a("meta"),x=l(),v=a("h1"),g=a("a"),j=a("span"),$(m.$$.fragment),k=l(),S=a("span"),ce=s("Accelerator"),ze=l(),M=a("p"),le=s("The "),O=a("a"),za=s("Accelerator"),Oa=s(` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),er=l(),ie=a("h2"),Oe=a("a"),go=a("span"),$(tr.$$.fragment),Rl=l(),_o=a("span"),Wl=s("Quick adaptation of your code"),Fs=l(),Ia=a("p"),Fl=s("To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),Hs=l(),Y=a("ol"),de=a("li"),Hl=s("Initialize an "),Sa=a("a"),Yl=s("Accelerator"),Bl=s(" object (that we will call "),vo=a("code"),Jl=s("accelerator"),Kl=s(" throughout this page) as early as possible in your script."),Ql=l(),rr=a("li"),Xl=s("Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),La=a("a"),Zl=s("prepare()"),ei=s(" method."),ti=l(),W=a("li"),ri=s("Remove all the "),$o=a("code"),ai=s(".cuda()"),oi=s(" or "),bo=a("code"),ni=s(".to(device)"),si=s(" from your code and let the "),yo=a("code"),ci=s("accelerator"),li=s(" handle the device placement for you."),Ys=l(),$(Ie.$$.fragment),Bs=l(),pe=a("ol"),Se=a("li"),ii=s("Replace "),wo=a("code"),di=s("loss.backward()"),pi=s(" in your code with "),Eo=a("code"),hi=s("accelerator.backward(loss)"),mi=l(),Na=a("li"),ui=s("Gather your predictions and labels before storing them or using them for metric computation using "),Ca=a("a"),fi=s("gather()"),Js=l(),$(Le.$$.fragment),Ks=l(),Ne=a("p"),gi=s(`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),Ao=a("code"),_i=s("accelerator"),vi=s(":"),Qs=l(),he=a("h2"),Ce=a("a"),ko=a("span"),$(ar.$$.fragment),$i=l(),xo=a("span"),bi=s("Advanced recommendations"),Xs=l(),me=a("h3"),qe=a("a"),jo=a("span"),$(or.$$.fragment),yi=l(),Po=a("span"),wi=s("Printing"),Zs=l(),ue=a("p"),Do=a("code"),Ei=s("print"),Ai=s(" statements should be replaced by "),qa=a("a"),ki=s("print()"),xi=s(" to be printed once per process"),ec=l(),$(nr.$$.fragment),tc=l(),fe=a("h3"),Ue=a("a"),To=a("span"),$(sr.$$.fragment),ji=l(),zo=a("span"),Pi=s("Executing processes"),rc=l(),ge=a("h4"),Ve=a("a"),Oo=a("span"),$(cr.$$.fragment),Di=l(),Io=a("span"),Ti=s("Once on a single server"),ac=l(),Me=a("p"),zi=s("For statements that should be executed once per server, use "),So=a("code"),Oi=s("is_local_main_process"),Ii=s(":"),oc=l(),$(lr.$$.fragment),nc=l(),Ge=a("p"),Si=s("A function can be wrapped using the "),Ua=a("a"),Li=s("on_local_main_process()"),Ni=s(` function to achieve the same
behavior on a function\u2019s execution:`),sc=l(),$(ir.$$.fragment),cc=l(),_e=a("h4"),Re=a("a"),Lo=a("span"),$(dr.$$.fragment),Ci=l(),No=a("span"),qi=s("Only ever once across all servers"),lc=l(),We=a("p"),Ui=s("For statements that should only ever be executed once, use "),Co=a("code"),Vi=s("is_main_process"),Mi=s(":"),ic=l(),$(pr.$$.fragment),dc=l(),Fe=a("p"),Gi=s("A function can be wrapped using the "),Va=a("a"),Ri=s("on_main_process()"),Wi=s(` function to achieve the same
behavior on a function\u2019s execution:`),pc=l(),$(hr.$$.fragment),hc=l(),ve=a("h4"),He=a("a"),qo=a("span"),$(mr.$$.fragment),Fi=l(),Uo=a("span"),Hi=s("On specific processes"),mc=l(),Ma=a("p"),Yi=s(`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),uc=l(),$(ur.$$.fragment),fc=l(),$(fr.$$.fragment),gc=l(),$e=a("h3"),Ye=a("a"),Vo=a("span"),$(gr.$$.fragment),Bi=l(),Mo=a("span"),Ji=s("Synchronicity control"),_c=l(),Be=a("p"),Ki=s("Use "),Ga=a("a"),Qi=s("wait_for_everyone()"),Xi=s(" to make sure all processes join that point before continuing. (Useful before a model save for instance)"),vc=l(),be=a("h3"),Je=a("a"),Go=a("span"),$(_r.$$.fragment),Zi=l(),Ro=a("span"),ed=s("Saving and loading"),$c=l(),Ke=a("p"),td=s("Use "),Ra=a("a"),rd=s("unwrap_model()"),ad=s(" before saving to remove all special model wrappers added during the distributed process."),bc=l(),$(vr.$$.fragment),yc=l(),B=a("p"),od=s("Use "),Wa=a("a"),nd=s("save()"),sd=s(" instead of "),Wo=a("code"),cd=s("torch.save"),ld=s(":"),wc=l(),$($r.$$.fragment),Ec=l(),ye=a("h3"),Qe=a("a"),Fo=a("span"),$(br.$$.fragment),id=l(),Ho=a("span"),dd=s("Operations"),Ac=l(),U=a("p"),pd=s("Use "),Xe=a("a"),hd=s("clip"),Yo=a("em"),md=s("grad_norm"),ud=s("()"),fd=s(" instead of "),Bo=a("code"),gd=s("torch.nn.utils.clip_grad_norm_"),_d=s(" and "),Ze=a("a"),vd=s("clip"),Jo=a("em"),$d=s("grad_value"),bd=s("()"),yd=s(" instead of "),Ko=a("code"),wd=s("torch.nn.utils.clip_grad_value"),kc=l(),we=a("h3"),et=a("a"),Qo=a("span"),$(yr.$$.fragment),Ed=l(),Xo=a("span"),Ad=s("Gradient Accumulation"),xc=l(),tt=a("p"),kd=s("To perform gradient accumulation use "),Fa=a("a"),xd=s("accumulate()"),jd=s(` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),jc=l(),$(wr.$$.fragment),Pc=l(),Ee=a("h2"),rt=a("a"),Zo=a("span"),$(Er.$$.fragment),Pd=l(),en=a("span"),Dd=s("Overall API documentation:"),Dc=l(),f=a("div"),$(Ar.$$.fragment),Td=l(),tn=a("p"),zd=s("Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Od=l(),rn=a("p"),an=a("strong"),Id=s("Available attributes:"),Sd=l(),T=a("ul"),at=a("li"),on=a("strong"),Ld=s("device"),Nd=s(" ("),nn=a("code"),Cd=s("torch.device"),qd=s(") \u2014 The device to use."),Ud=l(),ot=a("li"),sn=a("strong"),Vd=s("distributed_type"),Md=s(" ("),Ha=a("a"),Gd=s("DistributedType"),Rd=s(") \u2014 The distributed training configuration."),Wd=l(),nt=a("li"),cn=a("strong"),Fd=s("local_process_index"),Hd=s(" ("),ln=a("code"),Yd=s("int"),Bd=s(") \u2014 The process index on the current machine."),Jd=l(),st=a("li"),dn=a("strong"),Kd=s("mixed_precision"),Qd=s(" ("),pn=a("code"),Xd=s("str"),Zd=s(") \u2014 The configured mixed precision mode."),ep=l(),ct=a("li"),hn=a("strong"),tp=s("num_processes"),rp=s(" ("),mn=a("code"),ap=s("int"),op=s(") \u2014 The total number of processes used for training."),np=l(),lt=a("li"),un=a("strong"),sp=s("optimizer_step_was_skipped"),cp=s(" ("),fn=a("code"),lp=s("bool"),ip=s(`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),dp=l(),it=a("li"),gn=a("strong"),pp=s("process_index"),hp=s(" ("),_n=a("code"),mp=s("int"),up=s(") \u2014 The overall index of the current process among all processes."),fp=l(),dt=a("li"),vn=a("strong"),gp=s("state"),_p=s(" ("),Ya=a("a"),vp=s("AcceleratorState"),$p=s(") \u2014 The distributed setup state."),bp=l(),pt=a("li"),$n=a("strong"),yp=s("sync_gradients"),wp=s(" ("),bn=a("code"),Ep=s("bool"),Ap=s(") \u2014 Whether the gradients are currently being synced across all processes."),kp=l(),ht=a("li"),yn=a("strong"),xp=s("use_distributed"),jp=s(" ("),wn=a("code"),Pp=s("bool"),Dp=s(") \u2014 Whether the current configuration is for distributed training."),Tp=l(),J=a("div"),$(kr.$$.fragment),zp=l(),En=a("p"),Op=s("A context manager that will lightly wrap around and perform gradient accumulation automatically"),Ip=l(),$(mt.$$.fragment),Sp=l(),ut=a("div"),$(xr.$$.fragment),Lp=l(),An=a("p"),Np=s(`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),Cp=l(),K=a("div"),$(jr.$$.fragment),qp=l(),Ae=a("p"),Up=s("Scales the gradients in accordance to "),kn=a("code"),Vp=s("Accelerator.gradient_accumulation_steps"),Mp=s(` and calls the correct
`),xn=a("code"),Gp=s("backward()"),Rp=s(" based on the configuration."),Wp=l(),Pr=a("p"),Fp=s("Should be used in lieu of "),jn=a("code"),Hp=s("loss.backward()"),Yp=s("."),Bp=l(),ft=a("div"),$(Dr.$$.fragment),Jp=l(),Tr=a("p"),Kp=s("Alias for "),Pn=a("code"),Qp=s("Accelerate.free_memory"),Xp=s(`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),Zp=l(),Q=a("div"),$(zr.$$.fragment),eh=l(),Or=a("p"),th=s("Should be used in place of "),Dn=a("code"),rh=s("torch.nn.utils.clip_grad_norm_"),ah=s("."),oh=l(),$(gt.$$.fragment),nh=l(),X=a("div"),$(Ir.$$.fragment),sh=l(),Sr=a("p"),ch=s("Should be used in place of "),Tn=a("code"),lh=s("torch.nn.utils.clip_grad_value_"),ih=s("."),dh=l(),$(_t.$$.fragment),ph=l(),vt=a("div"),$(Lr.$$.fragment),hh=l(),zn=a("p"),mh=s(`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),uh=l(),$t=a("div"),$(Nr.$$.fragment),fh=l(),On=a("p"),gh=s(`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),_h=l(),Z=a("div"),$(Cr.$$.fragment),vh=l(),qr=a("p"),$h=s("Gather the values in "),In=a("em"),bh=s("tensor"),yh=s(` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),wh=l(),Sn=a("p"),Eh=s(`Note:
This gather happens in all processes.`),Ah=l(),bt=a("div"),$(Ur.$$.fragment),kh=l(),Vr=a("p"),xh=s("Gathers "),Ln=a("code"),jh=s("tensor"),Ph=s(` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),Dh=l(),yt=a("div"),$(Mr.$$.fragment),Th=l(),Gr=a("p"),zh=s("Returns the state dictionary of a model sent through "),Ba=a("a"),Oh=s("Accelerator.prepare()"),Ih=s(" in full precision"),Sh=l(),wt=a("div"),$(Rr.$$.fragment),Lh=l(),F=a("p"),Nh=s("Returns a "),Nn=a("code"),Ch=s("tracker"),qh=s(" from "),Cn=a("code"),Uh=s("self.trackers"),Vh=s(" based on "),qn=a("code"),Mh=s("name"),Gh=s(" on the main process only."),Rh=l(),Et=a("div"),$(Wr.$$.fragment),Wh=l(),Fr=a("p"),Fh=s("Initializes a run for all trackers stored in "),Un=a("code"),Hh=s("self.log_with"),Yh=s(", potentially with starting configurations"),Bh=l(),N=a("div"),$(Hr.$$.fragment),Jh=l(),Yr=a("p"),Kh=s(`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),Vn=a("code"),Qh=s("torch.distributed.algorithms.join"),Xh=s(`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),Zh=l(),$(At.$$.fragment),em=l(),$(kt.$$.fragment),tm=l(),$(xt.$$.fragment),rm=l(),ee=a("div"),$(Br.$$.fragment),am=l(),Mn=a("p"),om=s("Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),nm=l(),$(jt.$$.fragment),sm=l(),te=a("div"),$(Jr.$$.fragment),cm=l(),Gn=a("p"),lm=s("Lets the local main process go inside a with block."),im=l(),Rn=a("p"),dm=s("The other processes will enter the with block after the main process exits."),pm=l(),Pt=a("div"),$(Kr.$$.fragment),hm=l(),ke=a("p"),mm=s("Logs "),Wn=a("code"),um=s("values"),fm=s(" to all stored trackers in "),Fn=a("code"),gm=s("self.trackers"),_m=s(" on the main process only."),vm=l(),re=a("div"),$(Qr.$$.fragment),$m=l(),Hn=a("p"),bm=s("Lets the main process go first inside a with block."),ym=l(),Yn=a("p"),wm=s("The other processes will enter the with block after the main process exits."),Em=l(),G=a("div"),$(Xr.$$.fragment),Am=l(),Zr=a("p"),km=s(`A context manager to disable gradient synchronizations across DDP processes by calling
`),Bn=a("code"),xm=s("torch.nn.parallel.DistributedDataParallel.no_sync"),jm=s("."),Pm=l(),ea=a("p"),Dm=s("If "),Jn=a("code"),Tm=s("model"),zm=s(" is not in DDP, this context manager does nothing"),Om=l(),$(Dt.$$.fragment),Im=l(),Tt=a("div"),$(ta.$$.fragment),Sm=l(),Kn=a("p"),Lm=s("A decorator that will run the decorated function on the last process only."),Nm=l(),zt=a("div"),$(ra.$$.fragment),Cm=l(),Qn=a("p"),qm=s("A decorator that will run the decorated function on the local main process only."),Um=l(),Ot=a("div"),$(aa.$$.fragment),Vm=l(),Xn=a("p"),Mm=s("A decorator that will run the decorated function on a given local process index only."),Gm=l(),It=a("div"),$(oa.$$.fragment),Rm=l(),Zn=a("p"),Wm=s("A decorator that will run the decorated function on the main process only."),Fm=l(),St=a("div"),$(na.$$.fragment),Hm=l(),es=a("p"),Ym=s("A decorator that will run the decorated function on a given process index only."),Bm=l(),Lt=a("div"),$(sa.$$.fragment),Jm=l(),ts=a("p"),Km=s(`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),Qm=l(),ae=a("div"),$(ca.$$.fragment),Xm=l(),la=a("p"),Zm=s("Prepare all objects passed in "),rs=a("code"),eu=s("args"),tu=s(` for distributed training and mixed precision, then return them in the same
order.`),ru=l(),$(Nt.$$.fragment),au=l(),Ct=a("div"),$(ia.$$.fragment),ou=l(),da=a("p"),nu=s(`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),Ja=a("a"),su=s("Accelerator.prepare()"),cu=s(" instead."),lu=l(),qt=a("div"),$(pa.$$.fragment),iu=l(),ha=a("p"),du=s(`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),Ka=a("a"),pu=s("Accelerator.prepare()"),hu=s(" instead."),mu=l(),Ut=a("div"),$(ma.$$.fragment),uu=l(),ua=a("p"),fu=s(`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),Qa=a("a"),gu=s("Accelerator.prepare()"),_u=s(" instead."),vu=l(),Vt=a("div"),$(fa.$$.fragment),$u=l(),ga=a("p"),bu=s(`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),Xa=a("a"),yu=s("Accelerator.prepare()"),wu=s(" instead."),Eu=l(),Mt=a("div"),$(_a.$$.fragment),Au=l(),va=a("p"),ku=s("Use in replacement of "),as=a("code"),xu=s("print()"),ju=s(" to only print once per server."),Pu=l(),oe=a("div"),$($a.$$.fragment),Du=l(),xe=a("p"),Tu=s("Reduce the values in "),os=a("em"),zu=s("tensor"),Ou=s(" across all processes based on "),ns=a("em"),Iu=s("reduction"),Su=s("."),Lu=l(),ss=a("p"),Nu=s(`Note:
All processes get the reduced value.`),Cu=l(),R=a("div"),$(ba.$$.fragment),qu=l(),H=a("p"),Uu=s("Makes note of "),cs=a("code"),Vu=s("objects"),Mu=s(" and will save or load them in during "),ls=a("code"),Gu=s("save_state"),Ru=s(" or "),is=a("code"),Wu=s("load_state"),Fu=s("."),Hu=l(),ds=a("p"),Yu=s(`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts`),Bu=l(),$(Gt.$$.fragment),Ju=l(),Rt=a("div"),$(ya.$$.fragment),Ku=l(),wa=a("p"),Qu=s("Save the object passed to disk once per machine. Use in place of "),ps=a("code"),Xu=s("torch.save"),Zu=s("."),ef=l(),C=a("div"),$(Ea.$$.fragment),tf=l(),hs=a("p"),rf=s("Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),af=l(),I=a("p"),of=s("If a "),ms=a("code"),nf=s("ProjectConfiguration"),sf=s(" was passed to the "),us=a("code"),cf=s("Accelerator"),lf=s(" object with "),fs=a("code"),df=s("automatic_checkpoint_naming"),pf=s(` enabled
then checkpoints will be saved to `),gs=a("code"),hf=s("self.project_dir/checkpoints"),mf=s(`. If the number of current saves is greater
than `),_s=a("code"),uf=s("total_limit"),ff=s(` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),vs=a("code"),gf=s("checkpoint_<iteration>"),_f=s("."),vf=l(),Aa=a("p"),$f=s("Otherwise they are just saved to "),$s=a("code"),bf=s("output_dir"),yf=s("."),wf=l(),$(Wt.$$.fragment),Ef=l(),Ft=a("div"),$(ka.$$.fragment),Af=l(),bs=a("p"),kf=s("Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),xf=l(),Ht=a("div"),$(xa.$$.fragment),jf=l(),je=a("p"),Pf=s("Unwraps the "),ys=a("code"),Df=s("model"),Tf=s(" from the additional layer possible added by "),Za=a("a"),zf=s("prepare()"),Of=s(`. Useful before saving
the model.`),If=l(),Yt=a("div"),$(ja.$$.fragment),Sf=l(),ws=a("p"),Lf=s(`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),this.h()},l(t){const p=bv('[data-svelte="svelte-1phssyn"]',document.head);h=o(p,"META",{name:!0,content:!0}),p.forEach(r),x=i(t),v=o(t,"H1",{class:!0});var Pa=n(v);g=o(Pa,"A",{id:!0,class:!0,href:!0});var Es=n(g);j=o(Es,"SPAN",{});var As=n(j);b(m.$$.fragment,As),As.forEach(r),Es.forEach(r),k=i(Pa),S=o(Pa,"SPAN",{});var ks=n(S);ce=c(ks,"Accelerator"),ks.forEach(r),Pa.forEach(r),ze=i(t),M=o(t,"P",{});var Da=n(M);le=c(Da,"The "),O=o(Da,"A",{href:!0});var xs=n(O);za=c(xs,"Accelerator"),xs.forEach(r),Oa=c(Da,` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),Da.forEach(r),er=i(t),ie=o(t,"H2",{class:!0});var Ta=n(ie);Oe=o(Ta,"A",{id:!0,class:!0,href:!0});var js=n(Oe);go=o(js,"SPAN",{});var Ps=n(go);b(tr.$$.fragment,Ps),Ps.forEach(r),js.forEach(r),Rl=i(Ta),_o=o(Ta,"SPAN",{});var Ds=n(_o);Wl=c(Ds,"Quick adaptation of your code"),Ds.forEach(r),Ta.forEach(r),Fs=i(t),Ia=o(t,"P",{});var Ts=n(Ia);Fl=c(Ts,"To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),Ts.forEach(r),Hs=i(t),Y=o(t,"OL",{});var Pe=n(Y);de=o(Pe,"LI",{});var De=n(de);Hl=c(De,"Initialize an "),Sa=o(De,"A",{href:!0});var Cf=n(Sa);Yl=c(Cf,"Accelerator"),Cf.forEach(r),Bl=c(De," object (that we will call "),vo=o(De,"CODE",{});var qf=n(vo);Jl=c(qf,"accelerator"),qf.forEach(r),Kl=c(De," throughout this page) as early as possible in your script."),De.forEach(r),Ql=i(Pe),rr=o(Pe,"LI",{});var zc=n(rr);Xl=c(zc,"Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),La=o(zc,"A",{href:!0});var Uf=n(La);Zl=c(Uf,"prepare()"),Uf.forEach(r),ei=c(zc," method."),zc.forEach(r),ti=i(Pe),W=o(Pe,"LI",{});var Bt=n(W);ri=c(Bt,"Remove all the "),$o=o(Bt,"CODE",{});var Vf=n($o);ai=c(Vf,".cuda()"),Vf.forEach(r),oi=c(Bt," or "),bo=o(Bt,"CODE",{});var Mf=n(bo);ni=c(Mf,".to(device)"),Mf.forEach(r),si=c(Bt," from your code and let the "),yo=o(Bt,"CODE",{});var Gf=n(yo);ci=c(Gf,"accelerator"),Gf.forEach(r),li=c(Bt," handle the device placement for you."),Bt.forEach(r),Pe.forEach(r),Ys=i(t),b(Ie.$$.fragment,t),Bs=i(t),pe=o(t,"OL",{start:!0});var Oc=n(pe);Se=o(Oc,"LI",{});var zs=n(Se);ii=c(zs,"Replace "),wo=o(zs,"CODE",{});var Rf=n(wo);di=c(Rf,"loss.backward()"),Rf.forEach(r),pi=c(zs," in your code with "),Eo=o(zs,"CODE",{});var Wf=n(Eo);hi=c(Wf,"accelerator.backward(loss)"),Wf.forEach(r),zs.forEach(r),mi=i(Oc),Na=o(Oc,"LI",{});var Nf=n(Na);ui=c(Nf,"Gather your predictions and labels before storing them or using them for metric computation using "),Ca=o(Nf,"A",{href:!0});var Ff=n(Ca);fi=c(Ff,"gather()"),Ff.forEach(r),Nf.forEach(r),Oc.forEach(r),Js=i(t),b(Le.$$.fragment,t),Ks=i(t),Ne=o(t,"P",{});var Ic=n(Ne);gi=c(Ic,`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),Ao=o(Ic,"CODE",{});var Hf=n(Ao);_i=c(Hf,"accelerator"),Hf.forEach(r),vi=c(Ic,":"),Ic.forEach(r),Qs=i(t),he=o(t,"H2",{class:!0});var Sc=n(he);Ce=o(Sc,"A",{id:!0,class:!0,href:!0});var Yf=n(Ce);ko=o(Yf,"SPAN",{});var Bf=n(ko);b(ar.$$.fragment,Bf),Bf.forEach(r),Yf.forEach(r),$i=i(Sc),xo=o(Sc,"SPAN",{});var Jf=n(xo);bi=c(Jf,"Advanced recommendations"),Jf.forEach(r),Sc.forEach(r),Xs=i(t),me=o(t,"H3",{class:!0});var Lc=n(me);qe=o(Lc,"A",{id:!0,class:!0,href:!0});var Kf=n(qe);jo=o(Kf,"SPAN",{});var Qf=n(jo);b(or.$$.fragment,Qf),Qf.forEach(r),Kf.forEach(r),yi=i(Lc),Po=o(Lc,"SPAN",{});var Xf=n(Po);wi=c(Xf,"Printing"),Xf.forEach(r),Lc.forEach(r),Zs=i(t),ue=o(t,"P",{});var Os=n(ue);Do=o(Os,"CODE",{});var Zf=n(Do);Ei=c(Zf,"print"),Zf.forEach(r),Ai=c(Os," statements should be replaced by "),qa=o(Os,"A",{href:!0});var eg=n(qa);ki=c(eg,"print()"),eg.forEach(r),xi=c(Os," to be printed once per process"),Os.forEach(r),ec=i(t),b(nr.$$.fragment,t),tc=i(t),fe=o(t,"H3",{class:!0});var Nc=n(fe);Ue=o(Nc,"A",{id:!0,class:!0,href:!0});var tg=n(Ue);To=o(tg,"SPAN",{});var rg=n(To);b(sr.$$.fragment,rg),rg.forEach(r),tg.forEach(r),ji=i(Nc),zo=o(Nc,"SPAN",{});var ag=n(zo);Pi=c(ag,"Executing processes"),ag.forEach(r),Nc.forEach(r),rc=i(t),ge=o(t,"H4",{class:!0});var Cc=n(ge);Ve=o(Cc,"A",{id:!0,class:!0,href:!0});var og=n(Ve);Oo=o(og,"SPAN",{});var ng=n(Oo);b(cr.$$.fragment,ng),ng.forEach(r),og.forEach(r),Di=i(Cc),Io=o(Cc,"SPAN",{});var sg=n(Io);Ti=c(sg,"Once on a single server"),sg.forEach(r),Cc.forEach(r),ac=i(t),Me=o(t,"P",{});var qc=n(Me);zi=c(qc,"For statements that should be executed once per server, use "),So=o(qc,"CODE",{});var cg=n(So);Oi=c(cg,"is_local_main_process"),cg.forEach(r),Ii=c(qc,":"),qc.forEach(r),oc=i(t),b(lr.$$.fragment,t),nc=i(t),Ge=o(t,"P",{});var Uc=n(Ge);Si=c(Uc,"A function can be wrapped using the "),Ua=o(Uc,"A",{href:!0});var lg=n(Ua);Li=c(lg,"on_local_main_process()"),lg.forEach(r),Ni=c(Uc,` function to achieve the same
behavior on a function\u2019s execution:`),Uc.forEach(r),sc=i(t),b(ir.$$.fragment,t),cc=i(t),_e=o(t,"H4",{class:!0});var Vc=n(_e);Re=o(Vc,"A",{id:!0,class:!0,href:!0});var ig=n(Re);Lo=o(ig,"SPAN",{});var dg=n(Lo);b(dr.$$.fragment,dg),dg.forEach(r),ig.forEach(r),Ci=i(Vc),No=o(Vc,"SPAN",{});var pg=n(No);qi=c(pg,"Only ever once across all servers"),pg.forEach(r),Vc.forEach(r),lc=i(t),We=o(t,"P",{});var Mc=n(We);Ui=c(Mc,"For statements that should only ever be executed once, use "),Co=o(Mc,"CODE",{});var hg=n(Co);Vi=c(hg,"is_main_process"),hg.forEach(r),Mi=c(Mc,":"),Mc.forEach(r),ic=i(t),b(pr.$$.fragment,t),dc=i(t),Fe=o(t,"P",{});var Gc=n(Fe);Gi=c(Gc,"A function can be wrapped using the "),Va=o(Gc,"A",{href:!0});var mg=n(Va);Ri=c(mg,"on_main_process()"),mg.forEach(r),Wi=c(Gc,` function to achieve the same
behavior on a function\u2019s execution:`),Gc.forEach(r),pc=i(t),b(hr.$$.fragment,t),hc=i(t),ve=o(t,"H4",{class:!0});var Rc=n(ve);He=o(Rc,"A",{id:!0,class:!0,href:!0});var ug=n(He);qo=o(ug,"SPAN",{});var fg=n(qo);b(mr.$$.fragment,fg),fg.forEach(r),ug.forEach(r),Fi=i(Rc),Uo=o(Rc,"SPAN",{});var gg=n(Uo);Hi=c(gg,"On specific processes"),gg.forEach(r),Rc.forEach(r),mc=i(t),Ma=o(t,"P",{});var _g=n(Ma);Yi=c(_g,`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),_g.forEach(r),uc=i(t),b(ur.$$.fragment,t),fc=i(t),b(fr.$$.fragment,t),gc=i(t),$e=o(t,"H3",{class:!0});var Wc=n($e);Ye=o(Wc,"A",{id:!0,class:!0,href:!0});var vg=n(Ye);Vo=o(vg,"SPAN",{});var $g=n(Vo);b(gr.$$.fragment,$g),$g.forEach(r),vg.forEach(r),Bi=i(Wc),Mo=o(Wc,"SPAN",{});var bg=n(Mo);Ji=c(bg,"Synchronicity control"),bg.forEach(r),Wc.forEach(r),_c=i(t),Be=o(t,"P",{});var Fc=n(Be);Ki=c(Fc,"Use "),Ga=o(Fc,"A",{href:!0});var yg=n(Ga);Qi=c(yg,"wait_for_everyone()"),yg.forEach(r),Xi=c(Fc," to make sure all processes join that point before continuing. (Useful before a model save for instance)"),Fc.forEach(r),vc=i(t),be=o(t,"H3",{class:!0});var Hc=n(be);Je=o(Hc,"A",{id:!0,class:!0,href:!0});var wg=n(Je);Go=o(wg,"SPAN",{});var Eg=n(Go);b(_r.$$.fragment,Eg),Eg.forEach(r),wg.forEach(r),Zi=i(Hc),Ro=o(Hc,"SPAN",{});var Ag=n(Ro);ed=c(Ag,"Saving and loading"),Ag.forEach(r),Hc.forEach(r),$c=i(t),Ke=o(t,"P",{});var Yc=n(Ke);td=c(Yc,"Use "),Ra=o(Yc,"A",{href:!0});var kg=n(Ra);rd=c(kg,"unwrap_model()"),kg.forEach(r),ad=c(Yc," before saving to remove all special model wrappers added during the distributed process."),Yc.forEach(r),bc=i(t),b(vr.$$.fragment,t),yc=i(t),B=o(t,"P",{});var eo=n(B);od=c(eo,"Use "),Wa=o(eo,"A",{href:!0});var xg=n(Wa);nd=c(xg,"save()"),xg.forEach(r),sd=c(eo," instead of "),Wo=o(eo,"CODE",{});var jg=n(Wo);cd=c(jg,"torch.save"),jg.forEach(r),ld=c(eo,":"),eo.forEach(r),wc=i(t),b($r.$$.fragment,t),Ec=i(t),ye=o(t,"H3",{class:!0});var Bc=n(ye);Qe=o(Bc,"A",{id:!0,class:!0,href:!0});var Pg=n(Qe);Fo=o(Pg,"SPAN",{});var Dg=n(Fo);b(br.$$.fragment,Dg),Dg.forEach(r),Pg.forEach(r),id=i(Bc),Ho=o(Bc,"SPAN",{});var Tg=n(Ho);dd=c(Tg,"Operations"),Tg.forEach(r),Bc.forEach(r),Ac=i(t),U=o(t,"P",{});var Te=n(U);pd=c(Te,"Use "),Xe=o(Te,"A",{href:!0});var Jc=n(Xe);hd=c(Jc,"clip"),Yo=o(Jc,"EM",{});var zg=n(Yo);md=c(zg,"grad_norm"),zg.forEach(r),ud=c(Jc,"()"),Jc.forEach(r),fd=c(Te," instead of "),Bo=o(Te,"CODE",{});var Og=n(Bo);gd=c(Og,"torch.nn.utils.clip_grad_norm_"),Og.forEach(r),_d=c(Te," and "),Ze=o(Te,"A",{href:!0});var Kc=n(Ze);vd=c(Kc,"clip"),Jo=o(Kc,"EM",{});var Ig=n(Jo);$d=c(Ig,"grad_value"),Ig.forEach(r),bd=c(Kc,"()"),Kc.forEach(r),yd=c(Te," instead of "),Ko=o(Te,"CODE",{});var Sg=n(Ko);wd=c(Sg,"torch.nn.utils.clip_grad_value"),Sg.forEach(r),Te.forEach(r),kc=i(t),we=o(t,"H3",{class:!0});var Qc=n(we);et=o(Qc,"A",{id:!0,class:!0,href:!0});var Lg=n(et);Qo=o(Lg,"SPAN",{});var Ng=n(Qo);b(yr.$$.fragment,Ng),Ng.forEach(r),Lg.forEach(r),Ed=i(Qc),Xo=o(Qc,"SPAN",{});var Cg=n(Xo);Ad=c(Cg,"Gradient Accumulation"),Cg.forEach(r),Qc.forEach(r),xc=i(t),tt=o(t,"P",{});var Xc=n(tt);kd=c(Xc,"To perform gradient accumulation use "),Fa=o(Xc,"A",{href:!0});var qg=n(Fa);xd=c(qg,"accumulate()"),qg.forEach(r),jd=c(Xc,` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),Xc.forEach(r),jc=i(t),b(wr.$$.fragment,t),Pc=i(t),Ee=o(t,"H2",{class:!0});var Zc=n(Ee);rt=o(Zc,"A",{id:!0,class:!0,href:!0});var Ug=n(rt);Zo=o(Ug,"SPAN",{});var Vg=n(Zo);b(Er.$$.fragment,Vg),Vg.forEach(r),Ug.forEach(r),Pd=i(Zc),en=o(Zc,"SPAN",{});var Mg=n(en);Dd=c(Mg,"Overall API documentation:"),Mg.forEach(r),Zc.forEach(r),Dc=i(t),f=o(t,"DIV",{class:!0});var _=n(f);b(Ar.$$.fragment,_),Td=i(_),tn=o(_,"P",{});var Gg=n(tn);zd=c(Gg,"Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Gg.forEach(r),Od=i(_),rn=o(_,"P",{});var Rg=n(rn);an=o(Rg,"STRONG",{});var Wg=n(an);Id=c(Wg,"Available attributes:"),Wg.forEach(r),Rg.forEach(r),Sd=i(_),T=o(_,"UL",{});var z=n(T);at=o(z,"LI",{});var Is=n(at);on=o(Is,"STRONG",{});var Fg=n(on);Ld=c(Fg,"device"),Fg.forEach(r),Nd=c(Is," ("),nn=o(Is,"CODE",{});var Hg=n(nn);Cd=c(Hg,"torch.device"),Hg.forEach(r),qd=c(Is,") \u2014 The device to use."),Is.forEach(r),Ud=i(z),ot=o(z,"LI",{});var Ss=n(ot);sn=o(Ss,"STRONG",{});var Yg=n(sn);Vd=c(Yg,"distributed_type"),Yg.forEach(r),Md=c(Ss," ("),Ha=o(Ss,"A",{href:!0});var Bg=n(Ha);Gd=c(Bg,"DistributedType"),Bg.forEach(r),Rd=c(Ss,") \u2014 The distributed training configuration."),Ss.forEach(r),Wd=i(z),nt=o(z,"LI",{});var Ls=n(nt);cn=o(Ls,"STRONG",{});var Jg=n(cn);Fd=c(Jg,"local_process_index"),Jg.forEach(r),Hd=c(Ls," ("),ln=o(Ls,"CODE",{});var Kg=n(ln);Yd=c(Kg,"int"),Kg.forEach(r),Bd=c(Ls,") \u2014 The process index on the current machine."),Ls.forEach(r),Jd=i(z),st=o(z,"LI",{});var Ns=n(st);dn=o(Ns,"STRONG",{});var Qg=n(dn);Kd=c(Qg,"mixed_precision"),Qg.forEach(r),Qd=c(Ns," ("),pn=o(Ns,"CODE",{});var Xg=n(pn);Xd=c(Xg,"str"),Xg.forEach(r),Zd=c(Ns,") \u2014 The configured mixed precision mode."),Ns.forEach(r),ep=i(z),ct=o(z,"LI",{});var Cs=n(ct);hn=o(Cs,"STRONG",{});var Zg=n(hn);tp=c(Zg,"num_processes"),Zg.forEach(r),rp=c(Cs," ("),mn=o(Cs,"CODE",{});var e_=n(mn);ap=c(e_,"int"),e_.forEach(r),op=c(Cs,") \u2014 The total number of processes used for training."),Cs.forEach(r),np=i(z),lt=o(z,"LI",{});var qs=n(lt);un=o(qs,"STRONG",{});var t_=n(un);sp=c(t_,"optimizer_step_was_skipped"),t_.forEach(r),cp=c(qs," ("),fn=o(qs,"CODE",{});var r_=n(fn);lp=c(r_,"bool"),r_.forEach(r),ip=c(qs,`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),qs.forEach(r),dp=i(z),it=o(z,"LI",{});var Us=n(it);gn=o(Us,"STRONG",{});var a_=n(gn);pp=c(a_,"process_index"),a_.forEach(r),hp=c(Us," ("),_n=o(Us,"CODE",{});var o_=n(_n);mp=c(o_,"int"),o_.forEach(r),up=c(Us,") \u2014 The overall index of the current process among all processes."),Us.forEach(r),fp=i(z),dt=o(z,"LI",{});var Vs=n(dt);vn=o(Vs,"STRONG",{});var n_=n(vn);gp=c(n_,"state"),n_.forEach(r),_p=c(Vs," ("),Ya=o(Vs,"A",{href:!0});var s_=n(Ya);vp=c(s_,"AcceleratorState"),s_.forEach(r),$p=c(Vs,") \u2014 The distributed setup state."),Vs.forEach(r),bp=i(z),pt=o(z,"LI",{});var Ms=n(pt);$n=o(Ms,"STRONG",{});var c_=n($n);yp=c(c_,"sync_gradients"),c_.forEach(r),wp=c(Ms," ("),bn=o(Ms,"CODE",{});var l_=n(bn);Ep=c(l_,"bool"),l_.forEach(r),Ap=c(Ms,") \u2014 Whether the gradients are currently being synced across all processes."),Ms.forEach(r),kp=i(z),ht=o(z,"LI",{});var Gs=n(ht);yn=o(Gs,"STRONG",{});var i_=n(yn);xp=c(i_,"use_distributed"),i_.forEach(r),jp=c(Gs," ("),wn=o(Gs,"CODE",{});var d_=n(wn);Pp=c(d_,"bool"),d_.forEach(r),Dp=c(Gs,") \u2014 Whether the current configuration is for distributed training."),Gs.forEach(r),z.forEach(r),Tp=i(_),J=o(_,"DIV",{class:!0});var to=n(J);b(kr.$$.fragment,to),zp=i(to),En=o(to,"P",{});var p_=n(En);Op=c(p_,"A context manager that will lightly wrap around and perform gradient accumulation automatically"),p_.forEach(r),Ip=i(to),b(mt.$$.fragment,to),to.forEach(r),Sp=i(_),ut=o(_,"DIV",{class:!0});var el=n(ut);b(xr.$$.fragment,el),Lp=i(el),An=o(el,"P",{});var h_=n(An);Np=c(h_,`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),h_.forEach(r),el.forEach(r),Cp=i(_),K=o(_,"DIV",{class:!0});var ro=n(K);b(jr.$$.fragment,ro),qp=i(ro),Ae=o(ro,"P",{});var ao=n(Ae);Up=c(ao,"Scales the gradients in accordance to "),kn=o(ao,"CODE",{});var m_=n(kn);Vp=c(m_,"Accelerator.gradient_accumulation_steps"),m_.forEach(r),Mp=c(ao,` and calls the correct
`),xn=o(ao,"CODE",{});var u_=n(xn);Gp=c(u_,"backward()"),u_.forEach(r),Rp=c(ao," based on the configuration."),ao.forEach(r),Wp=i(ro),Pr=o(ro,"P",{});var tl=n(Pr);Fp=c(tl,"Should be used in lieu of "),jn=o(tl,"CODE",{});var f_=n(jn);Hp=c(f_,"loss.backward()"),f_.forEach(r),Yp=c(tl,"."),tl.forEach(r),ro.forEach(r),Bp=i(_),ft=o(_,"DIV",{class:!0});var rl=n(ft);b(Dr.$$.fragment,rl),Jp=i(rl),Tr=o(rl,"P",{});var al=n(Tr);Kp=c(al,"Alias for "),Pn=o(al,"CODE",{});var g_=n(Pn);Qp=c(g_,"Accelerate.free_memory"),g_.forEach(r),Xp=c(al,`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),al.forEach(r),rl.forEach(r),Zp=i(_),Q=o(_,"DIV",{class:!0});var oo=n(Q);b(zr.$$.fragment,oo),eh=i(oo),Or=o(oo,"P",{});var ol=n(Or);th=c(ol,"Should be used in place of "),Dn=o(ol,"CODE",{});var __=n(Dn);rh=c(__,"torch.nn.utils.clip_grad_norm_"),__.forEach(r),ah=c(ol,"."),ol.forEach(r),oh=i(oo),b(gt.$$.fragment,oo),oo.forEach(r),nh=i(_),X=o(_,"DIV",{class:!0});var no=n(X);b(Ir.$$.fragment,no),sh=i(no),Sr=o(no,"P",{});var nl=n(Sr);ch=c(nl,"Should be used in place of "),Tn=o(nl,"CODE",{});var v_=n(Tn);lh=c(v_,"torch.nn.utils.clip_grad_value_"),v_.forEach(r),ih=c(nl,"."),nl.forEach(r),dh=i(no),b(_t.$$.fragment,no),no.forEach(r),ph=i(_),vt=o(_,"DIV",{class:!0});var sl=n(vt);b(Lr.$$.fragment,sl),hh=i(sl),zn=o(sl,"P",{});var $_=n(zn);mh=c($_,`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),$_.forEach(r),sl.forEach(r),uh=i(_),$t=o(_,"DIV",{class:!0});var cl=n($t);b(Nr.$$.fragment,cl),fh=i(cl),On=o(cl,"P",{});var b_=n(On);gh=c(b_,`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),b_.forEach(r),cl.forEach(r),_h=i(_),Z=o(_,"DIV",{class:!0});var so=n(Z);b(Cr.$$.fragment,so),vh=i(so),qr=o(so,"P",{});var ll=n(qr);$h=c(ll,"Gather the values in "),In=o(ll,"EM",{});var y_=n(In);bh=c(y_,"tensor"),y_.forEach(r),yh=c(ll,` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),ll.forEach(r),wh=i(so),Sn=o(so,"P",{});var w_=n(Sn);Eh=c(w_,`Note:
This gather happens in all processes.`),w_.forEach(r),so.forEach(r),Ah=i(_),bt=o(_,"DIV",{class:!0});var il=n(bt);b(Ur.$$.fragment,il),kh=i(il),Vr=o(il,"P",{});var dl=n(Vr);xh=c(dl,"Gathers "),Ln=o(dl,"CODE",{});var E_=n(Ln);jh=c(E_,"tensor"),E_.forEach(r),Ph=c(dl,` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),dl.forEach(r),il.forEach(r),Dh=i(_),yt=o(_,"DIV",{class:!0});var pl=n(yt);b(Mr.$$.fragment,pl),Th=i(pl),Gr=o(pl,"P",{});var hl=n(Gr);zh=c(hl,"Returns the state dictionary of a model sent through "),Ba=o(hl,"A",{href:!0});var A_=n(Ba);Oh=c(A_,"Accelerator.prepare()"),A_.forEach(r),Ih=c(hl," in full precision"),hl.forEach(r),pl.forEach(r),Sh=i(_),wt=o(_,"DIV",{class:!0});var ml=n(wt);b(Rr.$$.fragment,ml),Lh=i(ml),F=o(ml,"P",{});var Jt=n(F);Nh=c(Jt,"Returns a "),Nn=o(Jt,"CODE",{});var k_=n(Nn);Ch=c(k_,"tracker"),k_.forEach(r),qh=c(Jt," from "),Cn=o(Jt,"CODE",{});var x_=n(Cn);Uh=c(x_,"self.trackers"),x_.forEach(r),Vh=c(Jt," based on "),qn=o(Jt,"CODE",{});var j_=n(qn);Mh=c(j_,"name"),j_.forEach(r),Gh=c(Jt," on the main process only."),Jt.forEach(r),ml.forEach(r),Rh=i(_),Et=o(_,"DIV",{class:!0});var ul=n(Et);b(Wr.$$.fragment,ul),Wh=i(ul),Fr=o(ul,"P",{});var fl=n(Fr);Fh=c(fl,"Initializes a run for all trackers stored in "),Un=o(fl,"CODE",{});var P_=n(Un);Hh=c(P_,"self.log_with"),P_.forEach(r),Yh=c(fl,", potentially with starting configurations"),fl.forEach(r),ul.forEach(r),Bh=i(_),N=o(_,"DIV",{class:!0});var ne=n(N);b(Hr.$$.fragment,ne),Jh=i(ne),Yr=o(ne,"P",{});var gl=n(Yr);Kh=c(gl,`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),Vn=o(gl,"CODE",{});var D_=n(Vn);Qh=c(D_,"torch.distributed.algorithms.join"),D_.forEach(r),Xh=c(gl,`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),gl.forEach(r),Zh=i(ne),b(At.$$.fragment,ne),em=i(ne),b(kt.$$.fragment,ne),tm=i(ne),b(xt.$$.fragment,ne),ne.forEach(r),rm=i(_),ee=o(_,"DIV",{class:!0});var co=n(ee);b(Br.$$.fragment,co),am=i(co),Mn=o(co,"P",{});var T_=n(Mn);om=c(T_,"Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),T_.forEach(r),nm=i(co),b(jt.$$.fragment,co),co.forEach(r),sm=i(_),te=o(_,"DIV",{class:!0});var lo=n(te);b(Jr.$$.fragment,lo),cm=i(lo),Gn=o(lo,"P",{});var z_=n(Gn);lm=c(z_,"Lets the local main process go inside a with block."),z_.forEach(r),im=i(lo),Rn=o(lo,"P",{});var O_=n(Rn);dm=c(O_,"The other processes will enter the with block after the main process exits."),O_.forEach(r),lo.forEach(r),pm=i(_),Pt=o(_,"DIV",{class:!0});var _l=n(Pt);b(Kr.$$.fragment,_l),hm=i(_l),ke=o(_l,"P",{});var io=n(ke);mm=c(io,"Logs "),Wn=o(io,"CODE",{});var I_=n(Wn);um=c(I_,"values"),I_.forEach(r),fm=c(io," to all stored trackers in "),Fn=o(io,"CODE",{});var S_=n(Fn);gm=c(S_,"self.trackers"),S_.forEach(r),_m=c(io," on the main process only."),io.forEach(r),_l.forEach(r),vm=i(_),re=o(_,"DIV",{class:!0});var po=n(re);b(Qr.$$.fragment,po),$m=i(po),Hn=o(po,"P",{});var L_=n(Hn);bm=c(L_,"Lets the main process go first inside a with block."),L_.forEach(r),ym=i(po),Yn=o(po,"P",{});var N_=n(Yn);wm=c(N_,"The other processes will enter the with block after the main process exits."),N_.forEach(r),po.forEach(r),Em=i(_),G=o(_,"DIV",{class:!0});var Kt=n(G);b(Xr.$$.fragment,Kt),Am=i(Kt),Zr=o(Kt,"P",{});var vl=n(Zr);km=c(vl,`A context manager to disable gradient synchronizations across DDP processes by calling
`),Bn=o(vl,"CODE",{});var C_=n(Bn);xm=c(C_,"torch.nn.parallel.DistributedDataParallel.no_sync"),C_.forEach(r),jm=c(vl,"."),vl.forEach(r),Pm=i(Kt),ea=o(Kt,"P",{});var $l=n(ea);Dm=c($l,"If "),Jn=o($l,"CODE",{});var q_=n(Jn);Tm=c(q_,"model"),q_.forEach(r),zm=c($l," is not in DDP, this context manager does nothing"),$l.forEach(r),Om=i(Kt),b(Dt.$$.fragment,Kt),Kt.forEach(r),Im=i(_),Tt=o(_,"DIV",{class:!0});var bl=n(Tt);b(ta.$$.fragment,bl),Sm=i(bl),Kn=o(bl,"P",{});var U_=n(Kn);Lm=c(U_,"A decorator that will run the decorated function on the last process only."),U_.forEach(r),bl.forEach(r),Nm=i(_),zt=o(_,"DIV",{class:!0});var yl=n(zt);b(ra.$$.fragment,yl),Cm=i(yl),Qn=o(yl,"P",{});var V_=n(Qn);qm=c(V_,"A decorator that will run the decorated function on the local main process only."),V_.forEach(r),yl.forEach(r),Um=i(_),Ot=o(_,"DIV",{class:!0});var wl=n(Ot);b(aa.$$.fragment,wl),Vm=i(wl),Xn=o(wl,"P",{});var M_=n(Xn);Mm=c(M_,"A decorator that will run the decorated function on a given local process index only."),M_.forEach(r),wl.forEach(r),Gm=i(_),It=o(_,"DIV",{class:!0});var El=n(It);b(oa.$$.fragment,El),Rm=i(El),Zn=o(El,"P",{});var G_=n(Zn);Wm=c(G_,"A decorator that will run the decorated function on the main process only."),G_.forEach(r),El.forEach(r),Fm=i(_),St=o(_,"DIV",{class:!0});var Al=n(St);b(na.$$.fragment,Al),Hm=i(Al),es=o(Al,"P",{});var R_=n(es);Ym=c(R_,"A decorator that will run the decorated function on a given process index only."),R_.forEach(r),Al.forEach(r),Bm=i(_),Lt=o(_,"DIV",{class:!0});var kl=n(Lt);b(sa.$$.fragment,kl),Jm=i(kl),ts=o(kl,"P",{});var W_=n(ts);Km=c(W_,`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),W_.forEach(r),kl.forEach(r),Qm=i(_),ae=o(_,"DIV",{class:!0});var ho=n(ae);b(ca.$$.fragment,ho),Xm=i(ho),la=o(ho,"P",{});var xl=n(la);Zm=c(xl,"Prepare all objects passed in "),rs=o(xl,"CODE",{});var F_=n(rs);eu=c(F_,"args"),F_.forEach(r),tu=c(xl,` for distributed training and mixed precision, then return them in the same
order.`),xl.forEach(r),ru=i(ho),b(Nt.$$.fragment,ho),ho.forEach(r),au=i(_),Ct=o(_,"DIV",{class:!0});var jl=n(Ct);b(ia.$$.fragment,jl),ou=i(jl),da=o(jl,"P",{});var Pl=n(da);nu=c(Pl,`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),Ja=o(Pl,"A",{href:!0});var H_=n(Ja);su=c(H_,"Accelerator.prepare()"),H_.forEach(r),cu=c(Pl," instead."),Pl.forEach(r),jl.forEach(r),lu=i(_),qt=o(_,"DIV",{class:!0});var Dl=n(qt);b(pa.$$.fragment,Dl),iu=i(Dl),ha=o(Dl,"P",{});var Tl=n(ha);du=c(Tl,`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),Ka=o(Tl,"A",{href:!0});var Y_=n(Ka);pu=c(Y_,"Accelerator.prepare()"),Y_.forEach(r),hu=c(Tl," instead."),Tl.forEach(r),Dl.forEach(r),mu=i(_),Ut=o(_,"DIV",{class:!0});var zl=n(Ut);b(ma.$$.fragment,zl),uu=i(zl),ua=o(zl,"P",{});var Ol=n(ua);fu=c(Ol,`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),Qa=o(Ol,"A",{href:!0});var B_=n(Qa);gu=c(B_,"Accelerator.prepare()"),B_.forEach(r),_u=c(Ol," instead."),Ol.forEach(r),zl.forEach(r),vu=i(_),Vt=o(_,"DIV",{class:!0});var Il=n(Vt);b(fa.$$.fragment,Il),$u=i(Il),ga=o(Il,"P",{});var Sl=n(ga);bu=c(Sl,`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),Xa=o(Sl,"A",{href:!0});var J_=n(Xa);yu=c(J_,"Accelerator.prepare()"),J_.forEach(r),wu=c(Sl," instead."),Sl.forEach(r),Il.forEach(r),Eu=i(_),Mt=o(_,"DIV",{class:!0});var Ll=n(Mt);b(_a.$$.fragment,Ll),Au=i(Ll),va=o(Ll,"P",{});var Nl=n(va);ku=c(Nl,"Use in replacement of "),as=o(Nl,"CODE",{});var K_=n(as);xu=c(K_,"print()"),K_.forEach(r),ju=c(Nl," to only print once per server."),Nl.forEach(r),Ll.forEach(r),Pu=i(_),oe=o(_,"DIV",{class:!0});var mo=n(oe);b($a.$$.fragment,mo),Du=i(mo),xe=o(mo,"P",{});var uo=n(xe);Tu=c(uo,"Reduce the values in "),os=o(uo,"EM",{});var Q_=n(os);zu=c(Q_,"tensor"),Q_.forEach(r),Ou=c(uo," across all processes based on "),ns=o(uo,"EM",{});var X_=n(ns);Iu=c(X_,"reduction"),X_.forEach(r),Su=c(uo,"."),uo.forEach(r),Lu=i(mo),ss=o(mo,"P",{});var Z_=n(ss);Nu=c(Z_,`Note:
All processes get the reduced value.`),Z_.forEach(r),mo.forEach(r),Cu=i(_),R=o(_,"DIV",{class:!0});var Qt=n(R);b(ba.$$.fragment,Qt),qu=i(Qt),H=o(Qt,"P",{});var Xt=n(H);Uu=c(Xt,"Makes note of "),cs=o(Xt,"CODE",{});var ev=n(cs);Vu=c(ev,"objects"),ev.forEach(r),Mu=c(Xt," and will save or load them in during "),ls=o(Xt,"CODE",{});var tv=n(ls);Gu=c(tv,"save_state"),tv.forEach(r),Ru=c(Xt," or "),is=o(Xt,"CODE",{});var rv=n(is);Wu=c(rv,"load_state"),rv.forEach(r),Fu=c(Xt,"."),Xt.forEach(r),Hu=i(Qt),ds=o(Qt,"P",{});var av=n(ds);Yu=c(av,`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts`),av.forEach(r),Bu=i(Qt),b(Gt.$$.fragment,Qt),Qt.forEach(r),Ju=i(_),Rt=o(_,"DIV",{class:!0});var Cl=n(Rt);b(ya.$$.fragment,Cl),Ku=i(Cl),wa=o(Cl,"P",{});var ql=n(wa);Qu=c(ql,"Save the object passed to disk once per machine. Use in place of "),ps=o(ql,"CODE",{});var ov=n(ps);Xu=c(ov,"torch.save"),ov.forEach(r),Zu=c(ql,"."),ql.forEach(r),Cl.forEach(r),ef=i(_),C=o(_,"DIV",{class:!0});var se=n(C);b(Ea.$$.fragment,se),tf=i(se),hs=o(se,"P",{});var nv=n(hs);rf=c(nv,"Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),nv.forEach(r),af=i(se),I=o(se,"P",{});var q=n(I);of=c(q,"If a "),ms=o(q,"CODE",{});var sv=n(ms);nf=c(sv,"ProjectConfiguration"),sv.forEach(r),sf=c(q," was passed to the "),us=o(q,"CODE",{});var cv=n(us);cf=c(cv,"Accelerator"),cv.forEach(r),lf=c(q," object with "),fs=o(q,"CODE",{});var lv=n(fs);df=c(lv,"automatic_checkpoint_naming"),lv.forEach(r),pf=c(q,` enabled
then checkpoints will be saved to `),gs=o(q,"CODE",{});var iv=n(gs);hf=c(iv,"self.project_dir/checkpoints"),iv.forEach(r),mf=c(q,`. If the number of current saves is greater
than `),_s=o(q,"CODE",{});var dv=n(_s);uf=c(dv,"total_limit"),dv.forEach(r),ff=c(q,` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),vs=o(q,"CODE",{});var pv=n(vs);gf=c(pv,"checkpoint_<iteration>"),pv.forEach(r),_f=c(q,"."),q.forEach(r),vf=i(se),Aa=o(se,"P",{});var Ul=n(Aa);$f=c(Ul,"Otherwise they are just saved to "),$s=o(Ul,"CODE",{});var hv=n($s);bf=c(hv,"output_dir"),hv.forEach(r),yf=c(Ul,"."),Ul.forEach(r),wf=i(se),b(Wt.$$.fragment,se),se.forEach(r),Ef=i(_),Ft=o(_,"DIV",{class:!0});var Vl=n(Ft);b(ka.$$.fragment,Vl),Af=i(Vl),bs=o(Vl,"P",{});var mv=n(bs);kf=c(mv,"Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),mv.forEach(r),Vl.forEach(r),xf=i(_),Ht=o(_,"DIV",{class:!0});var Ml=n(Ht);b(xa.$$.fragment,Ml),jf=i(Ml),je=o(Ml,"P",{});var fo=n(je);Pf=c(fo,"Unwraps the "),ys=o(fo,"CODE",{});var uv=n(ys);Df=c(uv,"model"),uv.forEach(r),Tf=c(fo," from the additional layer possible added by "),Za=o(fo,"A",{href:!0});var fv=n(Za);zf=c(fv,"prepare()"),fv.forEach(r),Of=c(fo,`. Useful before saving
the model.`),fo.forEach(r),Ml.forEach(r),If=i(_),Yt=o(_,"DIV",{class:!0});var Gl=n(Yt);b(ja.$$.fragment,Gl),Sf=i(Gl),ws=o(Gl,"P",{});var gv=n(ws);Lf=c(gv,`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),gv.forEach(r),Gl.forEach(r),_.forEach(r),this.h()},h(){d(h,"name","hf:doc:metadata"),d(h,"content",JSON.stringify(Nv)),d(g,"id","accelerator"),d(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(g,"href","#accelerator"),d(v,"class","relative group"),d(O,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator"),d(Oe,"id","quick-adaptation-of-your-code"),d(Oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Oe,"href","#quick-adaptation-of-your-code"),d(ie,"class","relative group"),d(Sa,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator"),d(La,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),d(Ca,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.gather"),d(pe,"start","4"),d(Ce,"id","advanced-recommendations"),d(Ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Ce,"href","#advanced-recommendations"),d(he,"class","relative group"),d(qe,"id","printing"),d(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(qe,"href","#printing"),d(me,"class","relative group"),d(qa,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.print"),d(Ue,"id","executing-processes"),d(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Ue,"href","#executing-processes"),d(fe,"class","relative group"),d(Ve,"id","once-on-a-single-server"),d(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Ve,"href","#once-on-a-single-server"),d(ge,"class","relative group"),d(Ua,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.on_local_main_process"),d(Re,"id","only-ever-once-across-all-servers"),d(Re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Re,"href","#only-ever-once-across-all-servers"),d(_e,"class","relative group"),d(Va,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.on_main_process"),d(He,"id","on-specific-processes"),d(He,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(He,"href","#on-specific-processes"),d(ve,"class","relative group"),d(Ye,"id","synchronicity-control"),d(Ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Ye,"href","#synchronicity-control"),d($e,"class","relative group"),d(Ga,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.wait_for_everyone"),d(Je,"id","saving-and-loading"),d(Je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Je,"href","#saving-and-loading"),d(be,"class","relative group"),d(Ra,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.unwrap_model"),d(Wa,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save"),d(Qe,"id","operations"),d(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Qe,"href","#operations"),d(ye,"class","relative group"),d(Xe,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),d(Ze,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),d(et,"id","gradient-accumulation"),d(et,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(et,"href","#gradient-accumulation"),d(we,"class","relative group"),d(Fa,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.accumulate"),d(rt,"id","accelerate.Accelerator"),d(rt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(rt,"href","#accelerate.Accelerator"),d(Ee,"class","relative group"),d(Ha,"href","/docs/accelerate/main/en/package_reference/utilities#accelerate.DistributedType"),d(Ya,"href","/docs/accelerate/main/en/package_reference/state#accelerate.state.AcceleratorState"),d(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d($t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(bt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ba,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),d(yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(zt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(It,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(St,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Lt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ja,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),d(Ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ka,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),d(qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Qa,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),d(Ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Xa,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),d(Vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Za,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),d(Ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,p){e(document.head,h),u(t,x,p),u(t,v,p),e(v,g),e(g,j),y(m,j,null),e(v,k),e(v,S),e(S,ce),u(t,ze,p),u(t,M,p),e(M,le),e(M,O),e(O,za),e(M,Oa),u(t,er,p),u(t,ie,p),e(ie,Oe),e(Oe,go),y(tr,go,null),e(ie,Rl),e(ie,_o),e(_o,Wl),u(t,Fs,p),u(t,Ia,p),e(Ia,Fl),u(t,Hs,p),u(t,Y,p),e(Y,de),e(de,Hl),e(de,Sa),e(Sa,Yl),e(de,Bl),e(de,vo),e(vo,Jl),e(de,Kl),e(Y,Ql),e(Y,rr),e(rr,Xl),e(rr,La),e(La,Zl),e(rr,ei),e(Y,ti),e(Y,W),e(W,ri),e(W,$o),e($o,ai),e(W,oi),e(W,bo),e(bo,ni),e(W,si),e(W,yo),e(yo,ci),e(W,li),u(t,Ys,p),y(Ie,t,p),u(t,Bs,p),u(t,pe,p),e(pe,Se),e(Se,ii),e(Se,wo),e(wo,di),e(Se,pi),e(Se,Eo),e(Eo,hi),e(pe,mi),e(pe,Na),e(Na,ui),e(Na,Ca),e(Ca,fi),u(t,Js,p),y(Le,t,p),u(t,Ks,p),u(t,Ne,p),e(Ne,gi),e(Ne,Ao),e(Ao,_i),e(Ne,vi),u(t,Qs,p),u(t,he,p),e(he,Ce),e(Ce,ko),y(ar,ko,null),e(he,$i),e(he,xo),e(xo,bi),u(t,Xs,p),u(t,me,p),e(me,qe),e(qe,jo),y(or,jo,null),e(me,yi),e(me,Po),e(Po,wi),u(t,Zs,p),u(t,ue,p),e(ue,Do),e(Do,Ei),e(ue,Ai),e(ue,qa),e(qa,ki),e(ue,xi),u(t,ec,p),y(nr,t,p),u(t,tc,p),u(t,fe,p),e(fe,Ue),e(Ue,To),y(sr,To,null),e(fe,ji),e(fe,zo),e(zo,Pi),u(t,rc,p),u(t,ge,p),e(ge,Ve),e(Ve,Oo),y(cr,Oo,null),e(ge,Di),e(ge,Io),e(Io,Ti),u(t,ac,p),u(t,Me,p),e(Me,zi),e(Me,So),e(So,Oi),e(Me,Ii),u(t,oc,p),y(lr,t,p),u(t,nc,p),u(t,Ge,p),e(Ge,Si),e(Ge,Ua),e(Ua,Li),e(Ge,Ni),u(t,sc,p),y(ir,t,p),u(t,cc,p),u(t,_e,p),e(_e,Re),e(Re,Lo),y(dr,Lo,null),e(_e,Ci),e(_e,No),e(No,qi),u(t,lc,p),u(t,We,p),e(We,Ui),e(We,Co),e(Co,Vi),e(We,Mi),u(t,ic,p),y(pr,t,p),u(t,dc,p),u(t,Fe,p),e(Fe,Gi),e(Fe,Va),e(Va,Ri),e(Fe,Wi),u(t,pc,p),y(hr,t,p),u(t,hc,p),u(t,ve,p),e(ve,He),e(He,qo),y(mr,qo,null),e(ve,Fi),e(ve,Uo),e(Uo,Hi),u(t,mc,p),u(t,Ma,p),e(Ma,Yi),u(t,uc,p),y(ur,t,p),u(t,fc,p),y(fr,t,p),u(t,gc,p),u(t,$e,p),e($e,Ye),e(Ye,Vo),y(gr,Vo,null),e($e,Bi),e($e,Mo),e(Mo,Ji),u(t,_c,p),u(t,Be,p),e(Be,Ki),e(Be,Ga),e(Ga,Qi),e(Be,Xi),u(t,vc,p),u(t,be,p),e(be,Je),e(Je,Go),y(_r,Go,null),e(be,Zi),e(be,Ro),e(Ro,ed),u(t,$c,p),u(t,Ke,p),e(Ke,td),e(Ke,Ra),e(Ra,rd),e(Ke,ad),u(t,bc,p),y(vr,t,p),u(t,yc,p),u(t,B,p),e(B,od),e(B,Wa),e(Wa,nd),e(B,sd),e(B,Wo),e(Wo,cd),e(B,ld),u(t,wc,p),y($r,t,p),u(t,Ec,p),u(t,ye,p),e(ye,Qe),e(Qe,Fo),y(br,Fo,null),e(ye,id),e(ye,Ho),e(Ho,dd),u(t,Ac,p),u(t,U,p),e(U,pd),e(U,Xe),e(Xe,hd),e(Xe,Yo),e(Yo,md),e(Xe,ud),e(U,fd),e(U,Bo),e(Bo,gd),e(U,_d),e(U,Ze),e(Ze,vd),e(Ze,Jo),e(Jo,$d),e(Ze,bd),e(U,yd),e(U,Ko),e(Ko,wd),u(t,kc,p),u(t,we,p),e(we,et),e(et,Qo),y(yr,Qo,null),e(we,Ed),e(we,Xo),e(Xo,Ad),u(t,xc,p),u(t,tt,p),e(tt,kd),e(tt,Fa),e(Fa,xd),e(tt,jd),u(t,jc,p),y(wr,t,p),u(t,Pc,p),u(t,Ee,p),e(Ee,rt),e(rt,Zo),y(Er,Zo,null),e(Ee,Pd),e(Ee,en),e(en,Dd),u(t,Dc,p),u(t,f,p),y(Ar,f,null),e(f,Td),e(f,tn),e(tn,zd),e(f,Od),e(f,rn),e(rn,an),e(an,Id),e(f,Sd),e(f,T),e(T,at),e(at,on),e(on,Ld),e(at,Nd),e(at,nn),e(nn,Cd),e(at,qd),e(T,Ud),e(T,ot),e(ot,sn),e(sn,Vd),e(ot,Md),e(ot,Ha),e(Ha,Gd),e(ot,Rd),e(T,Wd),e(T,nt),e(nt,cn),e(cn,Fd),e(nt,Hd),e(nt,ln),e(ln,Yd),e(nt,Bd),e(T,Jd),e(T,st),e(st,dn),e(dn,Kd),e(st,Qd),e(st,pn),e(pn,Xd),e(st,Zd),e(T,ep),e(T,ct),e(ct,hn),e(hn,tp),e(ct,rp),e(ct,mn),e(mn,ap),e(ct,op),e(T,np),e(T,lt),e(lt,un),e(un,sp),e(lt,cp),e(lt,fn),e(fn,lp),e(lt,ip),e(T,dp),e(T,it),e(it,gn),e(gn,pp),e(it,hp),e(it,_n),e(_n,mp),e(it,up),e(T,fp),e(T,dt),e(dt,vn),e(vn,gp),e(dt,_p),e(dt,Ya),e(Ya,vp),e(dt,$p),e(T,bp),e(T,pt),e(pt,$n),e($n,yp),e(pt,wp),e(pt,bn),e(bn,Ep),e(pt,Ap),e(T,kp),e(T,ht),e(ht,yn),e(yn,xp),e(ht,jp),e(ht,wn),e(wn,Pp),e(ht,Dp),e(f,Tp),e(f,J),y(kr,J,null),e(J,zp),e(J,En),e(En,Op),e(J,Ip),y(mt,J,null),e(f,Sp),e(f,ut),y(xr,ut,null),e(ut,Lp),e(ut,An),e(An,Np),e(f,Cp),e(f,K),y(jr,K,null),e(K,qp),e(K,Ae),e(Ae,Up),e(Ae,kn),e(kn,Vp),e(Ae,Mp),e(Ae,xn),e(xn,Gp),e(Ae,Rp),e(K,Wp),e(K,Pr),e(Pr,Fp),e(Pr,jn),e(jn,Hp),e(Pr,Yp),e(f,Bp),e(f,ft),y(Dr,ft,null),e(ft,Jp),e(ft,Tr),e(Tr,Kp),e(Tr,Pn),e(Pn,Qp),e(Tr,Xp),e(f,Zp),e(f,Q),y(zr,Q,null),e(Q,eh),e(Q,Or),e(Or,th),e(Or,Dn),e(Dn,rh),e(Or,ah),e(Q,oh),y(gt,Q,null),e(f,nh),e(f,X),y(Ir,X,null),e(X,sh),e(X,Sr),e(Sr,ch),e(Sr,Tn),e(Tn,lh),e(Sr,ih),e(X,dh),y(_t,X,null),e(f,ph),e(f,vt),y(Lr,vt,null),e(vt,hh),e(vt,zn),e(zn,mh),e(f,uh),e(f,$t),y(Nr,$t,null),e($t,fh),e($t,On),e(On,gh),e(f,_h),e(f,Z),y(Cr,Z,null),e(Z,vh),e(Z,qr),e(qr,$h),e(qr,In),e(In,bh),e(qr,yh),e(Z,wh),e(Z,Sn),e(Sn,Eh),e(f,Ah),e(f,bt),y(Ur,bt,null),e(bt,kh),e(bt,Vr),e(Vr,xh),e(Vr,Ln),e(Ln,jh),e(Vr,Ph),e(f,Dh),e(f,yt),y(Mr,yt,null),e(yt,Th),e(yt,Gr),e(Gr,zh),e(Gr,Ba),e(Ba,Oh),e(Gr,Ih),e(f,Sh),e(f,wt),y(Rr,wt,null),e(wt,Lh),e(wt,F),e(F,Nh),e(F,Nn),e(Nn,Ch),e(F,qh),e(F,Cn),e(Cn,Uh),e(F,Vh),e(F,qn),e(qn,Mh),e(F,Gh),e(f,Rh),e(f,Et),y(Wr,Et,null),e(Et,Wh),e(Et,Fr),e(Fr,Fh),e(Fr,Un),e(Un,Hh),e(Fr,Yh),e(f,Bh),e(f,N),y(Hr,N,null),e(N,Jh),e(N,Yr),e(Yr,Kh),e(Yr,Vn),e(Vn,Qh),e(Yr,Xh),e(N,Zh),y(At,N,null),e(N,em),y(kt,N,null),e(N,tm),y(xt,N,null),e(f,rm),e(f,ee),y(Br,ee,null),e(ee,am),e(ee,Mn),e(Mn,om),e(ee,nm),y(jt,ee,null),e(f,sm),e(f,te),y(Jr,te,null),e(te,cm),e(te,Gn),e(Gn,lm),e(te,im),e(te,Rn),e(Rn,dm),e(f,pm),e(f,Pt),y(Kr,Pt,null),e(Pt,hm),e(Pt,ke),e(ke,mm),e(ke,Wn),e(Wn,um),e(ke,fm),e(ke,Fn),e(Fn,gm),e(ke,_m),e(f,vm),e(f,re),y(Qr,re,null),e(re,$m),e(re,Hn),e(Hn,bm),e(re,ym),e(re,Yn),e(Yn,wm),e(f,Em),e(f,G),y(Xr,G,null),e(G,Am),e(G,Zr),e(Zr,km),e(Zr,Bn),e(Bn,xm),e(Zr,jm),e(G,Pm),e(G,ea),e(ea,Dm),e(ea,Jn),e(Jn,Tm),e(ea,zm),e(G,Om),y(Dt,G,null),e(f,Im),e(f,Tt),y(ta,Tt,null),e(Tt,Sm),e(Tt,Kn),e(Kn,Lm),e(f,Nm),e(f,zt),y(ra,zt,null),e(zt,Cm),e(zt,Qn),e(Qn,qm),e(f,Um),e(f,Ot),y(aa,Ot,null),e(Ot,Vm),e(Ot,Xn),e(Xn,Mm),e(f,Gm),e(f,It),y(oa,It,null),e(It,Rm),e(It,Zn),e(Zn,Wm),e(f,Fm),e(f,St),y(na,St,null),e(St,Hm),e(St,es),e(es,Ym),e(f,Bm),e(f,Lt),y(sa,Lt,null),e(Lt,Jm),e(Lt,ts),e(ts,Km),e(f,Qm),e(f,ae),y(ca,ae,null),e(ae,Xm),e(ae,la),e(la,Zm),e(la,rs),e(rs,eu),e(la,tu),e(ae,ru),y(Nt,ae,null),e(f,au),e(f,Ct),y(ia,Ct,null),e(Ct,ou),e(Ct,da),e(da,nu),e(da,Ja),e(Ja,su),e(da,cu),e(f,lu),e(f,qt),y(pa,qt,null),e(qt,iu),e(qt,ha),e(ha,du),e(ha,Ka),e(Ka,pu),e(ha,hu),e(f,mu),e(f,Ut),y(ma,Ut,null),e(Ut,uu),e(Ut,ua),e(ua,fu),e(ua,Qa),e(Qa,gu),e(ua,_u),e(f,vu),e(f,Vt),y(fa,Vt,null),e(Vt,$u),e(Vt,ga),e(ga,bu),e(ga,Xa),e(Xa,yu),e(ga,wu),e(f,Eu),e(f,Mt),y(_a,Mt,null),e(Mt,Au),e(Mt,va),e(va,ku),e(va,as),e(as,xu),e(va,ju),e(f,Pu),e(f,oe),y($a,oe,null),e(oe,Du),e(oe,xe),e(xe,Tu),e(xe,os),e(os,zu),e(xe,Ou),e(xe,ns),e(ns,Iu),e(xe,Su),e(oe,Lu),e(oe,ss),e(ss,Nu),e(f,Cu),e(f,R),y(ba,R,null),e(R,qu),e(R,H),e(H,Uu),e(H,cs),e(cs,Vu),e(H,Mu),e(H,ls),e(ls,Gu),e(H,Ru),e(H,is),e(is,Wu),e(H,Fu),e(R,Hu),e(R,ds),e(ds,Yu),e(R,Bu),y(Gt,R,null),e(f,Ju),e(f,Rt),y(ya,Rt,null),e(Rt,Ku),e(Rt,wa),e(wa,Qu),e(wa,ps),e(ps,Xu),e(wa,Zu),e(f,ef),e(f,C),y(Ea,C,null),e(C,tf),e(C,hs),e(hs,rf),e(C,af),e(C,I),e(I,of),e(I,ms),e(ms,nf),e(I,sf),e(I,us),e(us,cf),e(I,lf),e(I,fs),e(fs,df),e(I,pf),e(I,gs),e(gs,hf),e(I,mf),e(I,_s),e(_s,uf),e(I,ff),e(I,vs),e(vs,gf),e(I,_f),e(C,vf),e(C,Aa),e(Aa,$f),e(Aa,$s),e($s,bf),e(Aa,yf),e(C,wf),y(Wt,C,null),e(f,Ef),e(f,Ft),y(ka,Ft,null),e(Ft,Af),e(Ft,bs),e(bs,kf),e(f,xf),e(f,Ht),y(xa,Ht,null),e(Ht,jf),e(Ht,je),e(je,Pf),e(je,ys),e(ys,Df),e(je,Tf),e(je,Za),e(Za,zf),e(je,Of),e(f,If),e(f,Yt),y(ja,Yt,null),e(Yt,Sf),e(Yt,ws),e(ws,Lf),Tc=!0},p(t,[p]){const Pa={};p&2&&(Pa.$$scope={dirty:p,ctx:t}),Ie.$set(Pa);const Es={};p&2&&(Es.$$scope={dirty:p,ctx:t}),Le.$set(Es);const As={};p&2&&(As.$$scope={dirty:p,ctx:t}),mt.$set(As);const ks={};p&2&&(ks.$$scope={dirty:p,ctx:t}),gt.$set(ks);const Da={};p&2&&(Da.$$scope={dirty:p,ctx:t}),_t.$set(Da);const xs={};p&2&&(xs.$$scope={dirty:p,ctx:t}),At.$set(xs);const Ta={};p&2&&(Ta.$$scope={dirty:p,ctx:t}),kt.$set(Ta);const js={};p&2&&(js.$$scope={dirty:p,ctx:t}),xt.$set(js);const Ps={};p&2&&(Ps.$$scope={dirty:p,ctx:t}),jt.$set(Ps);const Ds={};p&2&&(Ds.$$scope={dirty:p,ctx:t}),Dt.$set(Ds);const Ts={};p&2&&(Ts.$$scope={dirty:p,ctx:t}),Nt.$set(Ts);const Pe={};p&2&&(Pe.$$scope={dirty:p,ctx:t}),Gt.$set(Pe);const De={};p&2&&(De.$$scope={dirty:p,ctx:t}),Wt.$set(De)},i(t){Tc||(w(m.$$.fragment,t),w(tr.$$.fragment,t),w(Ie.$$.fragment,t),w(Le.$$.fragment,t),w(ar.$$.fragment,t),w(or.$$.fragment,t),w(nr.$$.fragment,t),w(sr.$$.fragment,t),w(cr.$$.fragment,t),w(lr.$$.fragment,t),w(ir.$$.fragment,t),w(dr.$$.fragment,t),w(pr.$$.fragment,t),w(hr.$$.fragment,t),w(mr.$$.fragment,t),w(ur.$$.fragment,t),w(fr.$$.fragment,t),w(gr.$$.fragment,t),w(_r.$$.fragment,t),w(vr.$$.fragment,t),w($r.$$.fragment,t),w(br.$$.fragment,t),w(yr.$$.fragment,t),w(wr.$$.fragment,t),w(Er.$$.fragment,t),w(Ar.$$.fragment,t),w(kr.$$.fragment,t),w(mt.$$.fragment,t),w(xr.$$.fragment,t),w(jr.$$.fragment,t),w(Dr.$$.fragment,t),w(zr.$$.fragment,t),w(gt.$$.fragment,t),w(Ir.$$.fragment,t),w(_t.$$.fragment,t),w(Lr.$$.fragment,t),w(Nr.$$.fragment,t),w(Cr.$$.fragment,t),w(Ur.$$.fragment,t),w(Mr.$$.fragment,t),w(Rr.$$.fragment,t),w(Wr.$$.fragment,t),w(Hr.$$.fragment,t),w(At.$$.fragment,t),w(kt.$$.fragment,t),w(xt.$$.fragment,t),w(Br.$$.fragment,t),w(jt.$$.fragment,t),w(Jr.$$.fragment,t),w(Kr.$$.fragment,t),w(Qr.$$.fragment,t),w(Xr.$$.fragment,t),w(Dt.$$.fragment,t),w(ta.$$.fragment,t),w(ra.$$.fragment,t),w(aa.$$.fragment,t),w(oa.$$.fragment,t),w(na.$$.fragment,t),w(sa.$$.fragment,t),w(ca.$$.fragment,t),w(Nt.$$.fragment,t),w(ia.$$.fragment,t),w(pa.$$.fragment,t),w(ma.$$.fragment,t),w(fa.$$.fragment,t),w(_a.$$.fragment,t),w($a.$$.fragment,t),w(ba.$$.fragment,t),w(Gt.$$.fragment,t),w(ya.$$.fragment,t),w(Ea.$$.fragment,t),w(Wt.$$.fragment,t),w(ka.$$.fragment,t),w(xa.$$.fragment,t),w(ja.$$.fragment,t),Tc=!0)},o(t){E(m.$$.fragment,t),E(tr.$$.fragment,t),E(Ie.$$.fragment,t),E(Le.$$.fragment,t),E(ar.$$.fragment,t),E(or.$$.fragment,t),E(nr.$$.fragment,t),E(sr.$$.fragment,t),E(cr.$$.fragment,t),E(lr.$$.fragment,t),E(ir.$$.fragment,t),E(dr.$$.fragment,t),E(pr.$$.fragment,t),E(hr.$$.fragment,t),E(mr.$$.fragment,t),E(ur.$$.fragment,t),E(fr.$$.fragment,t),E(gr.$$.fragment,t),E(_r.$$.fragment,t),E(vr.$$.fragment,t),E($r.$$.fragment,t),E(br.$$.fragment,t),E(yr.$$.fragment,t),E(wr.$$.fragment,t),E(Er.$$.fragment,t),E(Ar.$$.fragment,t),E(kr.$$.fragment,t),E(mt.$$.fragment,t),E(xr.$$.fragment,t),E(jr.$$.fragment,t),E(Dr.$$.fragment,t),E(zr.$$.fragment,t),E(gt.$$.fragment,t),E(Ir.$$.fragment,t),E(_t.$$.fragment,t),E(Lr.$$.fragment,t),E(Nr.$$.fragment,t),E(Cr.$$.fragment,t),E(Ur.$$.fragment,t),E(Mr.$$.fragment,t),E(Rr.$$.fragment,t),E(Wr.$$.fragment,t),E(Hr.$$.fragment,t),E(At.$$.fragment,t),E(kt.$$.fragment,t),E(xt.$$.fragment,t),E(Br.$$.fragment,t),E(jt.$$.fragment,t),E(Jr.$$.fragment,t),E(Kr.$$.fragment,t),E(Qr.$$.fragment,t),E(Xr.$$.fragment,t),E(Dt.$$.fragment,t),E(ta.$$.fragment,t),E(ra.$$.fragment,t),E(aa.$$.fragment,t),E(oa.$$.fragment,t),E(na.$$.fragment,t),E(sa.$$.fragment,t),E(ca.$$.fragment,t),E(Nt.$$.fragment,t),E(ia.$$.fragment,t),E(pa.$$.fragment,t),E(ma.$$.fragment,t),E(fa.$$.fragment,t),E(_a.$$.fragment,t),E($a.$$.fragment,t),E(ba.$$.fragment,t),E(Gt.$$.fragment,t),E(ya.$$.fragment,t),E(Ea.$$.fragment,t),E(Wt.$$.fragment,t),E(ka.$$.fragment,t),E(xa.$$.fragment,t),E(ja.$$.fragment,t),Tc=!1},d(t){r(h),t&&r(x),t&&r(v),A(m),t&&r(ze),t&&r(M),t&&r(er),t&&r(ie),A(tr),t&&r(Fs),t&&r(Ia),t&&r(Hs),t&&r(Y),t&&r(Ys),A(Ie,t),t&&r(Bs),t&&r(pe),t&&r(Js),A(Le,t),t&&r(Ks),t&&r(Ne),t&&r(Qs),t&&r(he),A(ar),t&&r(Xs),t&&r(me),A(or),t&&r(Zs),t&&r(ue),t&&r(ec),A(nr,t),t&&r(tc),t&&r(fe),A(sr),t&&r(rc),t&&r(ge),A(cr),t&&r(ac),t&&r(Me),t&&r(oc),A(lr,t),t&&r(nc),t&&r(Ge),t&&r(sc),A(ir,t),t&&r(cc),t&&r(_e),A(dr),t&&r(lc),t&&r(We),t&&r(ic),A(pr,t),t&&r(dc),t&&r(Fe),t&&r(pc),A(hr,t),t&&r(hc),t&&r(ve),A(mr),t&&r(mc),t&&r(Ma),t&&r(uc),A(ur,t),t&&r(fc),A(fr,t),t&&r(gc),t&&r($e),A(gr),t&&r(_c),t&&r(Be),t&&r(vc),t&&r(be),A(_r),t&&r($c),t&&r(Ke),t&&r(bc),A(vr,t),t&&r(yc),t&&r(B),t&&r(wc),A($r,t),t&&r(Ec),t&&r(ye),A(br),t&&r(Ac),t&&r(U),t&&r(kc),t&&r(we),A(yr),t&&r(xc),t&&r(tt),t&&r(jc),A(wr,t),t&&r(Pc),t&&r(Ee),A(Er),t&&r(Dc),t&&r(f),A(Ar),A(kr),A(mt),A(xr),A(jr),A(Dr),A(zr),A(gt),A(Ir),A(_t),A(Lr),A(Nr),A(Cr),A(Ur),A(Mr),A(Rr),A(Wr),A(Hr),A(At),A(kt),A(xt),A(Br),A(jt),A(Jr),A(Kr),A(Qr),A(Xr),A(Dt),A(ta),A(ra),A(aa),A(oa),A(na),A(sa),A(ca),A(Nt),A(ia),A(pa),A(ma),A(fa),A(_a),A($a),A(ba),A(Gt),A(ya),A(Ea),A(Wt),A(ka),A(xa),A(ja)}}}const Nv={local:"accelerator",sections:[{local:"quick-adaptation-of-your-code",title:"Quick adaptation of your code"},{local:"advanced-recommendations",sections:[{local:"printing",title:"Printing"},{local:"executing-processes",sections:[{local:"once-on-a-single-server",title:"Once on a single server"},{local:"only-ever-once-across-all-servers",title:"Only ever once across all servers"},{local:"on-specific-processes",title:"On specific processes"}],title:"Executing processes"},{local:"synchronicity-control",title:"Synchronicity control"},{local:"saving-and-loading",title:"Saving and loading"},{local:"operations",title:"Operations"},{local:"gradient-accumulation",title:"Gradient Accumulation"}],title:"Advanced recommendations"},{local:"accelerate.Accelerator",title:"Overall API documentation:"}],title:"Accelerator"};function Cv(D){return yv(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wv extends _v{constructor(h){super();vv(this,h,Cv,Lv,$v,{})}}export{Wv as default,Nv as metadata};
